
/*
This file is automatically generated
by the software in /cm/paris/rel-3/defs/f6001/interface-fortran.lisp.  
ON:  Wednesday, 25 September 1991, 12:00:29
*/
#ifndef _PARIS_
#define _PARIS_

/*****************************************************************************
* 	  (c) Copyright 1991 Thinking Machines Corporation, Inc.,	     *
*		of Cambridge, Mass.   All rights reserved.		     *
*									     *
*  This notice is intended as a precaution against inadvertent publication   *
*  and does not constitute an admission or acknowledgement that publication  *
*  has occurred or constitute a waiver of confidentiality.		     *
*									     *
*  Connection Machine software is the proprietary and confidential property  *
*  of Thinking Machines Corporation.					     *
*****************************************************************************/

/*
 * The Connection Machine System Software
 * C/Paris header file
 */

#ifndef c_star
        /* C code */
#include <cm/cmtypes.h>

#else

        /* C* code */
#ifndef _ansi_prototypes
#define _ansi_prototypes 1
#endif
#include <cm/cmtypes.hs>

#endif

/* If _ansi_prototypes is defined, Paris will be declared with them. */
#ifndef _AP
#ifdef _ansi_prototypes
#define _AP(args)	args
#else
#define _AP(args)	()
#endif
#endif /* _AP */

/*
 * Array Format Definitions
 *  (The numbers were generated using encode-array-format.)
 */
#define CM_8_bit                ((CM_array_format_t) 74287)
#define CM_16_bit               ((CM_array_format_t) 76463)
#define CM_32_bit               ((CM_array_format_t) 78639)
#define CM_1_bit_packed         ((CM_array_format_t) 68143)
#define CM_2_bit_packed         ((CM_array_format_t) 70191)
#define CM_4_bit_packed         ((CM_array_format_t) 72239)
#define CM_float_single         ((CM_array_format_t) 78639)
#define CM_float_double         ((CM_array_format_t) 80815)
#define CM_complex_float_single ((CM_array_format_t) 80815)
#define CM_complex_float_double ((CM_array_format_t) 82991)

/*
 * OBSOLETE !!!
 */
#define CM_BYTE_ARRAY 		sizeof (char)
#define CM_SHORT_ARRAY 		sizeof (short)
#define CM_LONG_ARRAY 		sizeof (long)
#define CM_FLOAT_SINGLE_ARRAY 	sizeof (float)
#define CM_FLOAT_DOUBLE_ARRAY	sizeof (double)

#define CM_byte_array		CM_BYTE_ARRAY
#define CM_short_array		CM_SHORT_ARRAY
#define CM_long_array		CM_LONG_ARRAY
#define CM_float_single_array	CM_FLOAT_SINGLE_ARRAY
#define CM_float_double_array	CM_FLOAT_DOUBLE_ARRAY

/*
 * Bit ordering definitions
 */
#define CM_lsb_first 1
#define CM_msb_first 2
#define CM_front_end_order 3

/*
 * Array layout definitions.
 */
#define CM_row_major 0
#define CM_column_major 1

/*
 * some definitions for arguments to CM_attach
 */

#define CM_UCC0	1
#define CM_UCC1 2
#define CM_UCC2 4
#define CM_UCC3 8

/*
 * Values for flicking the lights.
 */
#define CM_LEDS_OFF	0
#define CM_leds_off	0
#define CM_LEDS_ON	1
#define CM_leds_on	1
#define	CM_LEDS_THROB	2	/* no longer supported */
#define	CM_leds_throb	2	/* no longer supported */
#define CM_LEDS_DIAGNOSTICS 3
#define CM_leds_diagnostics 3
#define CM_LEDS_PERFMON	4  	/* not supported */
#define CM_leds_perfmon	4  	/* not supported */
#define CM_LEDS_SYNC	5
#define CM_leds_sync	5
#define CM_LEDS_BLINK_SYNC 6
#define CM_leds_blink_sync 6
#define CM_LEDS_TIMER   7
#define CM_leds_timer   7

/*
 * Some "well-known" CM memory addresses:
 */
extern CM_memaddr_t CM_carry_flag;
extern CM_memaddr_t CM_overflow_flag;
extern CM_memaddr_t CM_test_flag;
extern CM_memaddr_t CM_context_flag;
extern CM_memaddr_t CM_physical_memory_limit;
extern CM_memaddr_t CM_float_flags;

/* 
 * Configuration variables.
 */
extern CM_vp_set_id_t	CM_current_vp_set;
extern int 	  	CM_physical_processors_limit;
extern int	  	CM_physical_processors_length;
extern int 	  	CM_physical_memory_length;

/*
 * The 5 basic CS constants.
 */
extern CM_memaddr_t CM_user_memory_address_limit;	/* m */
extern unsigned CM_user_x_dimension_limit;		/* v */
extern unsigned CM_user_y_dimension_limit;		/* w */
extern int CM_physical_x_dimension_limit;	/* p */
extern int CM_physical_y_dimension_limit;	/* q */

/*
 * These are derived from the basic 5.
 */
extern CM_cubeaddr_t CM_user_cube_address_limit;	  /* v*w */
extern int CM_physical_cube_address_limit;	  /* p*q */
extern CM_memaddr_t CM_full_virtual_memory_address_limit; /* m*v*w */
extern unsigned CM_virtual_to_physical_processor_ratio;	  /* (v*w)/(p*q) */
extern unsigned CM_x_virtual_to_physical_processor_ratio; /* v/p */
extern unsigned CM_y_virtual_to_physical_processor_ratio; /* w/q */
extern unsigned CM_user_memory_address_length;		  /* ceil(log2(m)) */
extern unsigned CM_cube_address_length;			  /* log2(v*w) */
extern unsigned CM_virtual_memory_address_length;	  /* ceil(log2(m*v*w)) */
extern unsigned CM_x_news_address_length;		  /* log2(v) */
extern unsigned CM_y_news_address_length;		  /* log2(w) */
extern unsigned CM_physical_cube_address_length;	  /* log2(p*q) */
extern unsigned CM_physical_x_news_address_length;	  /* log2(p) */
extern unsigned CM_physical_y_news_address_length;	  /* log2(q) */
extern unsigned CM_purely_virtual_cube_address_length;	  /* log2((v*w)/(p*q)) */
extern unsigned CM_purely_virtual_x_news_address_length;  /* log2(v/p) */
extern unsigned CM_purely_virtual_y_news_address_length;  /* log2(w/q) */

/*
 * Redundant names.
 */
#define CM_physical_number_of_processors_limit CM_physical_cube_address_limit
#define CM_user_number_of_processors_limit CM_user_cube_address_limit
#define CM_user_memory_limit _CMI_user_memory_limit
extern CM_memaddr_t _CMI_user_memory_limit;

/*
 * microcode parameters
 */

extern unsigned CM_microcode_version;
extern unsigned CM_maximum_message_length;
extern unsigned CM_maximum_integer_length;
extern unsigned CM_maximum_significand_length;
extern unsigned CM_maximum_exponent_length;
extern unsigned CM_number_of_timers;
extern int	CM_max_geometry_rank;

/*
 * Flags for "multiple value return" simulation.
 */
extern int    CM_no_processors_selected;
extern int    CM_conversion_overflow;

/*
 * VP mechanism configuration: 
 * user settable.
 */
extern int CM_heap_compression_messages_enabled;
extern int CM_heap_compression_enabled;

/*
 * Flag for send functions
 */
#ifdef cstar
extern int:void *CM_no_field ;
#else
extern int CM_no_field;
#endif

/*
 * Flags for cross-vp-move
 */
#define CM_cvpm_indexed		-2
#define CM_cvpm_mapped		-3

/*
 * Other useful stuff
 */
#define CM_NOLIMIT (-1)
#define CM_NOLIMITS (-1)

/* Name changes */

#define CM_u_move CM_move
#define CM_u_move_constant CM_move_constant
#define CM_u_move_always CM_move_always
#define CM_u_move_constant_always CM_move_constant_always
#define CM_u_floor_and_mod CM_u_truncate_and_rem
#define CM_u_truncate_divide CM_u_floor_divide
#define CM_u_mod CM_u_rem
#define CM_u_eq_constant CM_eq_constant
#define CM_u_ne_constant CM_ne_constant
#define CM_make_axis_descriptor _CMI_make_axis_descriptor
#define CM_random(destination,length) CM_u_random_with_limit((destination),(length),0)
#define CM_f_move_constant CM_f_move_constant_1L

#define CM_add_offset_to_field_id(field_id,offset) \
    ((CM_field_id_t)((int)(field_id)+(offset)))

/*
 * A pointer to a function to be called on CM software or hardware error.
 * Default value is generally abort().
 */
#define CM_abort_function	CMI_abort_function
extern void (*CM_abort_function)();

/*
 * A stdio stream for writing CM error messages.  
 * Default value is stderr
 */
#ifndef cstar
#ifdef stdout
#define CM_error_stream		CMI_error_stream
extern FILE *CM_error_stream;
#endif stdout
#endif

void CM_set_error_stream _AP((void *streamname));
void *CM_get_error_stream _AP((void));

/*
 * The FFT that is shipped with PARIS
 */

FFT_fft_setup_t CMSSL_c_fft_setup _AP((CM_geometry_id_t geometry));
void CMSSL_deallocate_setup _AP((FFT_fft_setup_t setup));
void CMSSL_c_c_fft _AP((CM_field_id_t dest,
			CM_field_id_t  src,
			FFT_fft_setup_t setup,
			FFT_ops_t ops,
			FFT_bit_orders_t in_bit_order,
			FFT_bit_orders_t out_bit_order,
			FFT_cm_orders_t in_cm_order,
			FFT_cm_orders_t out_cm_order,
			FFT_scales_t scale));

/*
 * The Matrix Multiply that is shipped with PARIS
 */

void CMSSL_s_matrix_multiply _AP((CM_field_id_t a,
				  CM_field_id_t b,
				  CM_field_id_t c));

void CMSSLc_matrix_multiply _AP((CM_field_id_t a,
				  CM_field_id_t b,
				  CM_field_id_t c));

/*
 * Back compatibility (rel-2) functions.
 */
void CM_abs _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_add _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_add2 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_add_carry _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_add_constant _AP((CM_memaddr_t, long, unsigned));
void CM_add_flags _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_add_scan _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_add_scan_backward _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_array_ref _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned, unsigned));
void CM_array_set _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned, unsigned));
void CM_ceiling _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_ceiling_and_remainder _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_ceiling_divide _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_compare _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_cube_from_x_y _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t));
void CM_enumerate _AP((CM_memaddr_t, unsigned));
unsigned CM_enumerate_and_count _AP((CM_memaddr_t, unsigned));
void CM_enumerate_for_rendezvous _AP((CM_memaddr_t));
void CM_eq _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_eq_constant _AP((CM_memaddr_t, long, unsigned));
void CM_f_abs _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_add _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_compare _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_f_divide _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_eq _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_float_signum _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_ge _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_gt _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_isminus _AP((CM_memaddr_t, unsigned, unsigned));
void CM_f_isplus _AP((CM_memaddr_t, unsigned, unsigned));
void CM_f_iszero _AP((CM_memaddr_t, unsigned, unsigned));
void CM_f_le _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_lt _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_max _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_max_scan _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_f_max_scan_backward _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_f_min _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_move _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
/* void CM_f_move_constant _AP((CM_memaddr_t, double, unsigned, unsigned)); */
void CM_f_move_decoded_constant _AP((CM_memaddr_t, long, long, long, unsigned, unsigned));
void CM_f_multiply _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_ne _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_negate _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_new_size _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned, unsigned));
void CM_f_rank _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_f_read_array_by_cube_addresses _AP((void *, unsigned, unsigned, CM_cubeaddr_t, CM_cubeaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_read_array_by_news_addresses _AP((void *, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, CM_memaddr_t, unsigned, unsigned));
double CM_f_read_from_processor _AP((CM_cubeaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_signum _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_f_sqrt _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_subtract _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_write_array_by_cube_addresses _AP((void *, unsigned, unsigned, CM_cubeaddr_t, CM_cubeaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_f_write_array_by_news_addresses _AP((void *, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, CM_memaddr_t, unsigned, unsigned));
void CM_f_write_to_processor _AP((CM_cubeaddr_t, CM_memaddr_t, double, unsigned, unsigned));
void CM_fetch _AP((CM_memaddr_t, CM_virtaddr_stripe_t, unsigned));
void CM_float _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_floor _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_floor_and_mod _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_floor_divide _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
CM_cubeaddr_t CM_front_end_cube_from_x_y _AP((unsigned, unsigned));
unsigned CM_front_end_gray_code_from_integer _AP((unsigned));
unsigned CM_front_end_integer_from_gray_code _AP((unsigned));
unsigned CM_front_end_x_from_cube _AP((CM_cubeaddr_t));
unsigned CM_front_end_y_from_cube _AP((CM_cubeaddr_t));
void CM_ge _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_ge_constant _AP((CM_memaddr_t, long, unsigned));
void CM_get _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned));
void CM_get_from_east _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_get_from_east_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_get_from_north _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_get_from_north_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_get_from_south _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_get_from_south_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_get_from_west _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_get_from_west_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
CM_memaddr_t CM_get_stack_pointer _AP((void));
CM_memaddr_t CM_stack _AP((unsigned));
CM_memaddr_t CM_get_stack_limit _AP((void));
CM_memaddr_t CM_get_stack_upper_bound _AP((void));
long CM_global_add _AP((CM_memaddr_t, unsigned));
long CM_global_count _AP((CM_memaddr_t));
long CM_global_count_always _AP((CM_memaddr_t));
double CM_global_f_add _AP((CM_memaddr_t, unsigned, unsigned));
double CM_global_f_max _AP((CM_memaddr_t, unsigned, unsigned));
double CM_global_f_min _AP((CM_memaddr_t, unsigned, unsigned));
unsigned CM_global_logand _AP((CM_memaddr_t, unsigned));
unsigned CM_global_logand_always _AP((CM_memaddr_t, unsigned));
unsigned CM_global_logior _AP((CM_memaddr_t, unsigned));
unsigned CM_global_logior_always _AP((CM_memaddr_t, unsigned));
long CM_global_max _AP((CM_memaddr_t, unsigned));
long CM_global_min _AP((CM_memaddr_t, unsigned));
unsigned CM_global_u_add _AP((CM_memaddr_t, unsigned));
unsigned CM_global_u_max _AP((CM_memaddr_t, unsigned));
unsigned CM_global_u_min _AP((CM_memaddr_t, unsigned));
void CM_gray_code_from_integer _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_gt _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_gt_constant _AP((CM_memaddr_t, long, unsigned));
void CM_init _AP((void));
void CM_initialize_random_number_generator _AP((int));
void CM_integer_from_gray_code _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_integer_length _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_isminus _AP((CM_memaddr_t, unsigned));
void CM_isplus _AP((CM_memaddr_t, unsigned));
void CM_isqrt _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_iszero _AP((CM_memaddr_t, unsigned));
void CM_le _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_le_constant _AP((CM_memaddr_t, long, unsigned));
void CM_logand _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logand_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logandc1 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logandc1_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logandc2 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logandc2_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logcount _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_logeqv _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logeqv_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logior _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logior_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_lognand _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_lognand_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_lognor _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_lognor_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_lognot _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_lognot_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logorc1 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logorc1_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logorc2 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logorc2_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logxor _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_logxor_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_lt _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_lt_constant _AP((CM_memaddr_t, long, unsigned));
void CM_max _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_max_constant _AP((CM_memaddr_t, long, unsigned));
void CM_max_scan _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_max_scan_backward _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_min _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_min_constant _AP((CM_memaddr_t, long, unsigned));
void CM_mod _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_move _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_move_always _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_move_constant _AP((CM_memaddr_t, long, unsigned));
void CM_move_constant_always _AP((CM_memaddr_t, long, unsigned));
void CM_move_reversed _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_move_string_constant _AP((CM_memaddr_t, void *, unsigned));
void CM_move_string_constant_always _AP((CM_memaddr_t, void *, unsigned));
void CM_multiply _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_multiply2 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_my_cube_address _AP((CM_memaddr_t));
void CM_my_x_address _AP((CM_memaddr_t));
void CM_my_y_address _AP((CM_memaddr_t));
void CM_ne _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_ne_constant _AP((CM_memaddr_t, long, unsigned));
void CM_negate _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_new_size _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_panic _AP((char *));
void CM_pop_and_discard _AP((unsigned));
void CM_processor_cons _AP((CM_memaddr_t, CM_memaddr_t));
void CM_push_space _AP((unsigned));
void CM_rank _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_read_array_by_cube_addresses _AP((void *, unsigned, unsigned, CM_cubeaddr_t, CM_cubeaddr_t, CM_memaddr_t, unsigned));
void CM_read_array_by_news_addresses _AP((void *, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, CM_memaddr_t, unsigned));
long CM_read_from_processor _AP((CM_cubeaddr_t, CM_memaddr_t, unsigned));
void CM_read_string_from_processor _AP((void *, CM_cubeaddr_t, CM_memaddr_t, unsigned));
void CM_rem _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_reset_stack_pointer _AP((void));
void CM_reset_timer _AP((void));
void CM_round _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_round_and_remainder _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_round_divide _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_send _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_send_with_add _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_send_with_logand _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_send_with_logior _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_send_with_logxor _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_send_with_max _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_send_with_min _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_send_with_overwrite _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_send_with_u_max _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_send_with_u_min _AP((CM_memaddr_t, CM_cubeaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_set_stack_limit _AP((CM_memaddr_t));
void CM_set_stack_pointer _AP((CM_memaddr_t));
void CM_set_stack_upper_bound _AP((CM_memaddr_t));
void CM_shift _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_signum _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_start_timer _AP((int));
CM_timeval_t * CM_stop_timer _AP((int));
void CM_store _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_store_with_add _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_store_with_logand _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_store_with_logior _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_store_with_logxor _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_store_with_max _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_store_with_min _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_store_with_overwrite _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_store_with_u_max _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_store_with_u_min _AP((CM_virtaddr_stripe_t, CM_memaddr_t, unsigned, int));
void CM_subtract _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_subtract2 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_subtract_borrow _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_subtract_constant _AP((CM_memaddr_t, long, unsigned));
void CM_truncate _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_truncate_and_rem _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_truncate_divide _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_add _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_add2 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_add_carry _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_add_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_add_flags _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_add_scan _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_u_add_scan_backward _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_u_ceiling _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_ceiling_and_remainder _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_ceiling_divide _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_compare _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_eq _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_eq_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_float _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_floor _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_floor_and_mod _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_floor_divide _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_ge _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_ge_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_gt _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_gt_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_integer_length _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_u_isplus _AP((CM_memaddr_t, unsigned));
void CM_u_isqrt _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_iszero _AP((CM_memaddr_t, unsigned));
void CM_u_le _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_le_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_logcount _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_u_lt _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_lt_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_max _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_max_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_max_scan _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_max_scan_backward _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_min _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_min_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_mod _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_multiply _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_multiply2 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_ne _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_ne_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_negate _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_new_size _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_u_random_with_limit _AP((CM_memaddr_t, unsigned, unsigned));
void CM_u_rank _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_u_read_array_by_cube_addresses _AP((void *, unsigned, unsigned, CM_cubeaddr_t, CM_cubeaddr_t, CM_memaddr_t, unsigned));
void CM_u_read_array_by_news_addresses _AP((void *, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, CM_memaddr_t, unsigned));
unsigned CM_u_read_from_processor _AP((CM_cubeaddr_t, CM_memaddr_t, unsigned));
void CM_u_rem _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_round _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_round_and_remainder _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_round_divide _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_shift _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_u_subtract _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_subtract2 _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_subtract_borrow _AP((CM_memaddr_t, CM_memaddr_t, unsigned));
void CM_u_subtract_constant _AP((CM_memaddr_t, long, unsigned));
void CM_u_truncate _AP((CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_truncate_and_rem _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_truncate_divide _AP((CM_memaddr_t, CM_memaddr_t, CM_memaddr_t, unsigned, unsigned, unsigned));
void CM_u_write_array_by_cube_addresses _AP((void *, unsigned, unsigned, CM_cubeaddr_t, CM_cubeaddr_t, CM_memaddr_t, unsigned));
void CM_u_write_array_by_news_addresses _AP((void *, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, CM_memaddr_t, unsigned));
void CM_u_write_to_processor _AP((CM_cubeaddr_t, CM_memaddr_t, unsigned, unsigned));
void CM_write_array_by_cube_addresses _AP((void *, unsigned, unsigned, CM_cubeaddr_t, CM_cubeaddr_t, CM_memaddr_t, unsigned));
void CM_write_array_by_news_addresses _AP((void *, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, CM_memaddr_t, unsigned));
void CM_write_string_to_processor _AP((CM_cubeaddr_t, CM_memaddr_t, void *, unsigned));
void CM_write_to_processor _AP((CM_cubeaddr_t, CM_memaddr_t, long, unsigned));
void CM_x_from_cube _AP((CM_memaddr_t, CM_memaddr_t));
void CM_y_from_cube _AP((CM_memaddr_t, CM_memaddr_t));

/*
 * The PARIS routines themselves.
 */

CM_field_id_t CM_allocate_heap_field _AP((unsigned length));

CM_field_id_t CM_allocate_heap_field_vp_set _AP((unsigned length, 
                                                 CM_vp_set_id_t vp_set_id));

CM_field_id_t CM_allocate_stack_field _AP((unsigned length));

CM_field_id_t CM_allocate_stack_field_vp_set _AP((unsigned length, 
                                                  CM_vp_set_id_t vp_set_id));

CM_vp_set_id_t CM_allocate_vp_set _AP((CM_geometry_id_t geometry_id));

void CM_aref_2L _AP((CM_field_id_t destination, 
                     CM_field_id_t array, 
                     CM_field_id_t index, 
                     unsigned dest_length, 
                     unsigned index_length, 
                     unsigned index_limit, 
                     unsigned element_length));

void CM_aref32_2L _AP((CM_field_id_t dest, 
                       CM_field_id_t array, 
                       CM_field_id_t index, 
                       unsigned dlen, 
                       unsigned index_len, 
                       unsigned index_limit));

void CM_aref32_always_2L _AP((CM_field_id_t dest, 
                              CM_field_id_t array, 
                              CM_field_id_t index, 
                              unsigned dlen, 
                              unsigned index_len, 
                              unsigned index_limit));

void CM_aref32_shared_2L _AP((CM_field_id_t dest, 
                              CM_field_id_t array, 
                              CM_field_id_t index, 
                              unsigned dlen, 
                              unsigned index_len, 
                              unsigned index_limit));

void CM_aref32_shared_always_2L _AP((CM_field_id_t dest, 
                                     CM_field_id_t array, 
                                     CM_field_id_t index, 
                                     unsigned dlen, 
                                     unsigned index_len, 
                                     unsigned index_limit));

void CM_aset_2L _AP((CM_field_id_t source, 
                     CM_field_id_t array, 
                     CM_field_id_t index, 
                     unsigned source_length, 
                     unsigned index_length, 
                     unsigned index_limit, 
                     unsigned element_length));

void CM_aset32_2L _AP((CM_field_id_t source, 
                       CM_field_id_t array, 
                       CM_field_id_t index, 
                       unsigned slen, 
                       unsigned index_len, 
                       unsigned index_limit));

void CM_aset32_shared_2L _AP((CM_field_id_t source, 
                              CM_field_id_t array, 
                              CM_field_id_t index, 
                              unsigned slen, 
                              unsigned index_len, 
                              unsigned index_limit));

int CM_attached _AP((void));

int CM_available_memory _AP((void));

void CM_c_acos_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_c_acos_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_c_acosh_1_1L _AP((CM_field_id_t dest, 
                          unsigned s, 
                          unsigned e));

void CM_c_acosh_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned s, 
                          unsigned e));

void CM_c_add_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_c_add_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned s, 
                        unsigned e));

void CM_c_add_always_2_1L _AP((CM_field_id_t dest, 
                               CM_field_id_t source, 
                               unsigned s, 
                               unsigned e));

void CM_c_add_always_3_1L _AP((CM_field_id_t dest, 
                               CM_field_id_t source1, 
                               CM_field_id_t source2, 
                               unsigned s, 
                               unsigned e));

void CM_c_add_const_always_2_1L _AP((CM_field_id_t dest, 
                                     CM_complex_t source1_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_add_const_always_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     CM_complex_t source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_add_constant_2_1L _AP((CM_field_id_t dest, 
                                 CM_complex_t source1_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_c_add_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 CM_complex_t source2_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_c_asin_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_c_asin_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_c_asinh_1_1L _AP((CM_field_id_t dest, 
                          unsigned s, 
                          unsigned e));

void CM_c_asinh_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned s, 
                          unsigned e));

void CM_c_atan_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_c_atan_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_c_atanh_1_1L _AP((CM_field_id_t dest, 
                          unsigned s, 
                          unsigned e));

void CM_c_atanh_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned s, 
                          unsigned e));

void CM_c_c_power_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned s, 
                            unsigned e));

void CM_c_c_power_3_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned s, 
                            unsigned e));

void CM_c_c_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     CM_complex_t source, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_c_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     CM_complex_t source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_c_signum_1_1L _AP((CM_field_id_t dest, 
                             unsigned s, 
                             unsigned e));

void CM_c_c_signum_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned s, 
                             unsigned e));

void CM_c_conjugate_1_1L _AP((CM_field_id_t dest, 
                              unsigned s, 
                              unsigned e));

void CM_c_conjugate_2_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned s, 
                              unsigned e));

void CM_c_cos_1_1L _AP((CM_field_id_t dest, 
                        unsigned s, 
                        unsigned e));

void CM_c_cos_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_c_cosh_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_c_cosh_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_c_divide_2_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned s, 
                           unsigned e));

void CM_c_divide_3_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source1, 
                           CM_field_id_t source2, 
                           unsigned s, 
                           unsigned e));

void CM_c_divide_always_2_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned s, 
                                  unsigned e));

void CM_c_divide_always_3_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  unsigned s, 
                                  unsigned e));

void CM_c_divide_const_always_2_1L _AP((CM_field_id_t dest, 
                                        CM_complex_t source1_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_c_divide_const_always_3_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        CM_complex_t source2_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_c_divide_constant_2_1L _AP((CM_field_id_t dest, 
                                    CM_complex_t source1_value, 
                                    unsigned s, 
                                    unsigned e));

void CM_c_divide_constant_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    CM_complex_t source2_value, 
                                    unsigned s, 
                                    unsigned e));

void CM_c_divinto_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned s, 
                            unsigned e));

void CM_c_divinto_always_2_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned s, 
                                   unsigned e));

void CM_c_divinto_const_always_2_1L _AP((CM_field_id_t dest, 
                                         CM_complex_t source1_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_c_divinto_const_always_3_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         CM_complex_t source2_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_c_divinto_constant_2_1L _AP((CM_field_id_t dest, 
                                     CM_complex_t source1_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_divinto_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     CM_complex_t source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_eq_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned s, 
                     unsigned e));

void CM_c_eq_constant_1L _AP((CM_field_id_t source1, 
                              CM_complex_t source2_value, 
                              unsigned s, 
                              unsigned e));

void CM_c_eq_zero_1L _AP((CM_field_id_t source1, 
                          unsigned s, 
                          unsigned e));

void CM_c_exp_1_1L _AP((CM_field_id_t dest, 
                        unsigned s, 
                        unsigned e));

void CM_c_exp_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_c_f_cis_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned s, 
                          unsigned e));

void CM_c_f_power_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned s, 
                            unsigned e));

void CM_c_f_power_3_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned s, 
                            unsigned e));

void CM_c_f_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     double source, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_f_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     double source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_ln_1_1L _AP((CM_field_id_t dest, 
                       unsigned s, 
                       unsigned e));

void CM_c_ln_2_1L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned s, 
                       unsigned e));

void CM_c_move_1L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned s, 
                       unsigned e));

void CM_c_move_2L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned ds, 
                       unsigned de, 
                       unsigned ss, 
                       unsigned se));

void CM_c_move_always_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned s, 
                              unsigned e));

void CM_c_move_const_always_1L _AP((CM_field_id_t dest, 
                                    CM_complex_t source1_value, 
                                    unsigned s, 
                                    unsigned e));

void CM_c_move_constant_1L _AP((CM_field_id_t dest, 
                                CM_complex_t source1_value, 
                                unsigned s, 
                                unsigned e));

void CM_c_move_zero_1L _AP((CM_field_id_t dest, 
                            unsigned s, 
                            unsigned e));

void CM_c_move_zero_always_1L _AP((CM_field_id_t dest, 
                                   unsigned s, 
                                   unsigned e));

void CM_c_multiply_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned s, 
                             unsigned e));

void CM_c_multiply_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned s, 
                             unsigned e));

void CM_c_multiply_always_2_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source, 
                                    unsigned s, 
                                    unsigned e));

void CM_c_multiply_always_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    CM_field_id_t source2, 
                                    unsigned s, 
                                    unsigned e));

void CM_c_multiply_const_always_2_1L _AP((CM_field_id_t dest, 
                                          CM_complex_t source1_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_c_multiply_const_always_3_1L _AP((CM_field_id_t dest, 
                                          CM_field_id_t source1, 
                                          CM_complex_t source2_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_c_multiply_constant_2_1L _AP((CM_field_id_t dest, 
                                      CM_complex_t source1_value, 
                                      unsigned s, 
                                      unsigned e));

void CM_c_multiply_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      CM_complex_t source2_value, 
                                      unsigned s, 
                                      unsigned e));

void CM_c_ne_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned s, 
                     unsigned e));

void CM_c_ne_constant_1L _AP((CM_field_id_t source1, 
                              CM_complex_t source2_value, 
                              unsigned s, 
                              unsigned e));

void CM_c_ne_zero_1L _AP((CM_field_id_t source1, 
                          unsigned s, 
                          unsigned e));

void CM_c_negate_1_1L _AP((CM_field_id_t dest, 
                           unsigned s, 
                           unsigned e));

void CM_c_negate_2_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned s, 
                           unsigned e));

void CM_c_read_from_news_array_1L _AP((char *front_end_array, 
                                       unsigned *offset_vector, 
                                       unsigned *start_vector, 
                                       unsigned *end_vector, 
                                       unsigned *axis_vector, 
                                       CM_field_id_t source_field, 
                                       unsigned signif_len, 
                                       unsigned exp_len, 
                                       int rank, 
                                       unsigned *dimension_vector, 
                                       unsigned format));

CM_complex_t CM_c_read_from_processor_1L _AP((CM_sendaddr_t send_address_value, 
                                              CM_field_id_t source, 
                                              unsigned s, 
                                              unsigned e));

void CM_c_reciprocal_1_1L _AP((CM_field_id_t dest, 
                               unsigned s, 
                               unsigned e));

void CM_c_reciprocal_2_1L _AP((CM_field_id_t dest, 
                               CM_field_id_t source, 
                               unsigned s, 
                               unsigned e));

void CM_c_s_power_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned slen, 
                            unsigned s, 
                            unsigned e));

void CM_c_s_power_3_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned slen2, 
                            unsigned s, 
                            unsigned e));

void CM_c_s_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     int source, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_s_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_sin_1_1L _AP((CM_field_id_t dest, 
                        unsigned s, 
                        unsigned e));

void CM_c_sin_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_c_sinh_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_c_sinh_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_c_sqrt_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_c_sqrt_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_c_subfrom_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned s, 
                            unsigned e));

void CM_c_subfrom_always_2_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned s, 
                                   unsigned e));

void CM_c_subfrom_const_always_2_1L _AP((CM_field_id_t dest, 
                                         CM_complex_t source1_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_c_subfrom_const_always_3_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         CM_complex_t source2_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_c_subfrom_constant_2_1L _AP((CM_field_id_t dest, 
                                     CM_complex_t source1_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_subfrom_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     CM_complex_t source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_subtract_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned s, 
                             unsigned e));

void CM_c_subtract_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned s, 
                             unsigned e));

void CM_c_subtract_always_2_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source, 
                                    unsigned s, 
                                    unsigned e));

void CM_c_subtract_always_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    CM_field_id_t source2, 
                                    unsigned s, 
                                    unsigned e));

void CM_c_subtract_const_always_2_1L _AP((CM_field_id_t dest, 
                                          CM_complex_t source1_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_c_subtract_const_always_3_1L _AP((CM_field_id_t dest, 
                                          CM_field_id_t source1, 
                                          CM_complex_t source2_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_c_subtract_constant_2_1L _AP((CM_field_id_t dest, 
                                      CM_complex_t source1_value, 
                                      unsigned s, 
                                      unsigned e));

void CM_c_subtract_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      CM_complex_t source2_value, 
                                      unsigned s, 
                                      unsigned e));

void CM_c_tan_1_1L _AP((CM_field_id_t dest, 
                        unsigned s, 
                        unsigned e));

void CM_c_tan_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_c_tanh_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_c_tanh_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_c_u_power_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t power, 
                            unsigned power_length, 
                            unsigned s, 
                            unsigned e));

void CM_c_u_power_3_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t power, 
                            unsigned power_length, 
                            unsigned s, 
                            unsigned e));

void CM_c_u_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     unsigned power, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_u_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     unsigned power, 
                                     unsigned s, 
                                     unsigned e));

void CM_c_write_to_news_array_1L _AP((char *front_end_array, 
                                      unsigned *offset_vector, 
                                      unsigned *start_vector, 
                                      unsigned *end_vector, 
                                      unsigned *axis_vector, 
                                      CM_field_id_t dest_field, 
                                      unsigned signif_len, 
                                      unsigned exp_len, 
                                      int rank, 
                                      unsigned *dimension_vector, 
                                      CM_array_format_t format));

void CM_c_write_to_processor_1L _AP((CM_sendaddr_t send_address_value, 
                                     CM_field_id_t dest, 
                                     CM_complex_t source_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_change_field_alias _AP((CM_field_id_t alias_field_id, 
                                CM_field_id_t field_id));

void CM_clear_all_flags _AP((void));

void CM_clear_all_flags_always _AP((void));

void CM_clear_bit _AP((CM_field_id_t dest));

void CM_clear_bit_always _AP((CM_field_id_t dest));

void CM_clear_context _AP((void));

void CM_clear_overflow _AP((void));

void CM_clear_test _AP((void));

void CM_compress_heap _AP((void));

CM_geometry_id_t CM_create_geometry _AP((unsigned *dimension_array, 
                                         unsigned rank));

void CM_cross_vp_move_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned *axis_mapping, 
                              unsigned *source_axis_coords, 
                              unsigned *dest_axis_coords, 
                              unsigned len));

void CM_cross_vp_move_always_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source, 
                                     unsigned *axis_mapping, 
                                     unsigned *source_axis_coords, 
                                     unsigned *dest_axis_coords, 
                                     unsigned len));

void CM_deallocate_geometry _AP((CM_geometry_id_t geometry_id));

void CM_deallocate_heap_field _AP((CM_field_id_t field_id));

void CM_deallocate_stack_through _AP((CM_field_id_t field_id));

void CM_deallocate_stack_to _AP((CM_field_id_t field_id, 
                                 unsigned length));

void CM_deallocate_vp_set _AP((CM_vp_set_id_t vp_set_id));

CM_vp_set_id_t CM_declare_vp_set _AP((CM_geometry_id_t geometry_id));

void CM_deposit_news_constant_1L _AP((CM_geometry_id_t geometry_id, 
                                      CM_field_id_t dest, 
                                      unsigned axis, 
                                      unsigned news_coordinate_value, 
                                      unsigned slen));

void CM_deposit_news_coordinate_1L _AP((CM_geometry_id_t geometry_id, 
                                        CM_field_id_t dest, 
                                        unsigned axis, 
                                        CM_field_id_t news_coordinate, 
                                        unsigned slen));

CM_field_id_t CM_do_not_notify_token _AP((void));

void CM_enumerate_1L _AP((CM_field_id_t dest, 
                          unsigned axis, 
                          unsigned len, 
                          CM_communication_direction_t direction, 
                          CM_scan_inclusion_t inclusion, 
                          CM_segment_mode_t smode, 
                          CM_field_id_t sbit));

void CM_extract_multi_coordinate_1L _AP((CM_geometry_id_t geometry_id, 
                                         CM_field_id_t dest, 
                                         unsigned axis_mask, 
                                         CM_field_id_t send_address, 
                                         unsigned dlen));

void CM_extract_news_coordinate_1L _AP((CM_geometry_id_t geometry_id, 
                                        CM_field_id_t dest, 
                                        unsigned axis, 
                                        CM_field_id_t send_address, 
                                        unsigned dlen));

void CM_f_abs_1_1L _AP((CM_field_id_t dest, 
                        unsigned s, 
                        unsigned e));

void CM_f_abs_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_acos_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_acos_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_f_acosh_1_1L _AP((CM_field_id_t dest, 
                          unsigned s, 
                          unsigned e));

void CM_f_acosh_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned s, 
                          unsigned e));

void CM_f_add_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_add_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned s, 
                        unsigned e));

void CM_f_add_always_2_1L _AP((CM_field_id_t dest, 
                               CM_field_id_t source, 
                               unsigned s, 
                               unsigned e));

void CM_f_add_always_3_1L _AP((CM_field_id_t dest, 
                               CM_field_id_t source1, 
                               CM_field_id_t source2, 
                               unsigned s, 
                               unsigned e));

void CM_f_add_const_always_2_1L _AP((CM_field_id_t dest, 
                                     double source1_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_add_const_always_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     double source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_add_const_mult_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 double source2_value, 
                                 CM_field_id_t source3, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_add_const_mult_always_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        CM_field_id_t source3, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_add_const_mult_const_1L _AP((CM_field_id_t dest, 
                                       CM_field_id_t source1, 
                                       double source2_value, 
                                       double source3_value, 
                                       unsigned s, 
                                       unsigned e));

void CM_f_add_const_mult_const_a_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         double source2_value, 
                                         double source3_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_add_constant_2_1L _AP((CM_field_id_t dest, 
                                 double source1_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_add_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 double source2_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_add_mult_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source1, 
                           CM_field_id_t source2, 
                           CM_field_id_t source3, 
                           unsigned s, 
                           unsigned e));

void CM_f_add_mult_always_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  CM_field_id_t source3, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_add_mult_const_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 CM_field_id_t source2, 
                                 double source3_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_add_mult_const_always_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        CM_field_id_t source2, 
                                        double source3_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_asin_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_asin_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_f_asinh_1_1L _AP((CM_field_id_t dest, 
                          unsigned s, 
                          unsigned e));

void CM_f_asinh_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned s, 
                          unsigned e));

void CM_f_atan_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_atan_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_f_atan2_3_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t y, 
                          CM_field_id_t x, 
                          unsigned s, 
                          unsigned e));

void CM_f_atanh_1_1L _AP((CM_field_id_t dest, 
                          unsigned s, 
                          unsigned e));

void CM_f_atanh_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned s, 
                          unsigned e));

void CM_f_c_abs_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned s, 
                          unsigned e));

void CM_f_c_phase_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned s, 
                            unsigned e));

void CM_f_compare_3_2L _AP((CM_field_id_t destination, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned dlen, 
                            unsigned s, 
                            unsigned e));

void CM_f_cos_1_1L _AP((CM_field_id_t dest, 
                        unsigned s, 
                        unsigned e));

void CM_f_cos_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_cosh_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_cosh_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_f_divide_2_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned s, 
                           unsigned e));

void CM_f_divide_3_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source1, 
                           CM_field_id_t source2, 
                           unsigned s, 
                           unsigned e));

void CM_f_divide_always_2_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_divide_always_3_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_divide_const_always_2_1L _AP((CM_field_id_t dest, 
                                        double source_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_divide_const_always_3_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_divide_constant_2_1L _AP((CM_field_id_t dest, 
                                    double source_value, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_divide_constant_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    double source2_value, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_divinto_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned s, 
                            unsigned e));

void CM_f_divinto_always_2_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned s, 
                                   unsigned e));

void CM_f_divinto_const_always_2_1L _AP((CM_field_id_t dest, 
                                         double source_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_divinto_const_always_3_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         double source2_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_divinto_constant_2_1L _AP((CM_field_id_t dest, 
                                     double source_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_divinto_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     double source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_eq_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned s, 
                     unsigned e));

void CM_f_eq_constant_1L _AP((CM_field_id_t source1, 
                              double source2_value, 
                              unsigned s, 
                              unsigned e));

void CM_f_eq_zero_1L _AP((CM_field_id_t source1, 
                          unsigned s, 
                          unsigned e));

void CM_f_exp_1_1L _AP((CM_field_id_t dest, 
                        unsigned s, 
                        unsigned e));

void CM_f_exp_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_exp2_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_exp2_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_f_f_ceiling_1_1L _AP((CM_field_id_t dest, 
                              unsigned s, 
                              unsigned e));

void CM_f_f_ceiling_2_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned s, 
                              unsigned e));

void CM_f_f_floor_1_1L _AP((CM_field_id_t dest, 
                            unsigned s, 
                            unsigned e));

void CM_f_f_floor_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned s, 
                            unsigned e));

void CM_f_f_power_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned s, 
                            unsigned e));

void CM_f_f_power_3_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned s, 
                            unsigned e));

void CM_f_f_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     double source_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_f_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     double source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_f_round_1_1L _AP((CM_field_id_t dest, 
                            unsigned s, 
                            unsigned e));

void CM_f_f_round_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned s, 
                            unsigned e));

void CM_f_f_signum_1_1L _AP((CM_field_id_t dest, 
                             unsigned s, 
                             unsigned e));

void CM_f_f_signum_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned s, 
                             unsigned e));

void CM_f_f_truncate_1_1L _AP((CM_field_id_t dest, 
                               unsigned s, 
                               unsigned e));

void CM_f_f_truncate_2_1L _AP((CM_field_id_t dest, 
                               CM_field_id_t source, 
                               unsigned s, 
                               unsigned e));

void CM_f_ge_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned s, 
                     unsigned e));

void CM_f_ge_constant_1L _AP((CM_field_id_t source1, 
                              double source2_value, 
                              unsigned s, 
                              unsigned e));

void CM_f_ge_zero_1L _AP((CM_field_id_t source1, 
                          unsigned s, 
                          unsigned e));

void CM_f_gt_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned s, 
                     unsigned e));

void CM_f_gt_constant_1L _AP((CM_field_id_t source1, 
                              double source2_value, 
                              unsigned s, 
                              unsigned e));

void CM_f_gt_zero_1L _AP((CM_field_id_t source1, 
                          unsigned s, 
                          unsigned e));

void CM_f_ieee_to_vax_1L _AP((CM_field_id_t vax_dest_field, 
                              CM_field_id_t ieee_source_field, 
                              unsigned float_length));

void CM_f_le_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned s, 
                     unsigned e));

void CM_f_le_constant_1L _AP((CM_field_id_t source1, 
                              double source2_value, 
                              unsigned s, 
                              unsigned e));

void CM_f_le_zero_1L _AP((CM_field_id_t source1, 
                          unsigned s, 
                          unsigned e));

void CM_f_ln_1_1L _AP((CM_field_id_t dest, 
                       unsigned s, 
                       unsigned e));

void CM_f_ln_2_1L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned s, 
                       unsigned e));

void CM_f_log10_1_1L _AP((CM_field_id_t dest, 
                          unsigned s, 
                          unsigned e));

void CM_f_log10_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned s, 
                          unsigned e));

void CM_f_log2_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_log2_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_f_lt_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned s, 
                     unsigned e));

void CM_f_lt_constant_1L _AP((CM_field_id_t source1, 
                              double source2_value, 
                              unsigned s, 
                              unsigned e));

void CM_f_lt_zero_1L _AP((CM_field_id_t source1, 
                          unsigned s, 
                          unsigned e));

void CM_f_max_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_max_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned s, 
                        unsigned e));

void CM_f_max_constant_2_1L _AP((CM_field_id_t dest, 
                                 double source_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_max_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 double source2_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_min_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_min_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned s, 
                        unsigned e));

void CM_f_min_constant_2_1L _AP((CM_field_id_t dest, 
                                 double source_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_min_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 double source2_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_mod_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_mod_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned s, 
                        unsigned e));

void CM_f_mod_constant_2_1L _AP((CM_field_id_t dest, 
                                 double source_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_mod_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 double source2_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_move_1L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned s, 
                       unsigned e));

void CM_f_move_2L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned ds, 
                       unsigned de, 
                       unsigned ss, 
                       unsigned se));

void CM_f_move_always_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned s, 
                              unsigned e));

void CM_f_move_const_always_1L _AP((CM_field_id_t dest, 
                                    double source_value, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_move_constant_1L _AP((CM_field_id_t dest, 
                                double source_value, 
                                unsigned s, 
                                unsigned e));

void CM_f_move_decoded_constant_1L _AP((CM_field_id_t destination, 
                                        int low_s_value, 
                                        int high_s_value, 
                                        int expt_constant, 
                                        int sign_constant, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_move_zero_1L _AP((CM_field_id_t dest, 
                            unsigned s, 
                            unsigned e));

void CM_f_move_zero_always_1L _AP((CM_field_id_t dest, 
                                   unsigned s, 
                                   unsigned e));

void CM_f_mult_add_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source1, 
                           CM_field_id_t source2, 
                           CM_field_id_t source3, 
                           unsigned s, 
                           unsigned e));

void CM_f_mult_add_always_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  CM_field_id_t source3, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_mult_add_const_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 CM_field_id_t source2, 
                                 double source3_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_mult_add_const_always_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        CM_field_id_t source2, 
                                        double source3_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_mult_const_add_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 double source2_value, 
                                 CM_field_id_t source3, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_mult_const_add_always_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        CM_field_id_t source3, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_mult_const_add_const_1L _AP((CM_field_id_t dest, 
                                       CM_field_id_t source1, 
                                       double source2_value, 
                                       double source3_value, 
                                       unsigned s, 
                                       unsigned e));

void CM_f_mult_const_add_const_a_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         double source2_value, 
                                         double source3_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_mult_const_sub_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 double source2_value, 
                                 CM_field_id_t source3, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_mult_const_sub_always_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        CM_field_id_t source3, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_mult_const_sub_const_1L _AP((CM_field_id_t dest, 
                                       CM_field_id_t source1, 
                                       double source2_value, 
                                       double source3_value, 
                                       unsigned s, 
                                       unsigned e));

void CM_f_mult_const_sub_const_a_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         double source2_value, 
                                         double source3_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_mult_const_subf_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  double source2_value, 
                                  CM_field_id_t source3, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_mult_const_subf_always_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         double source2_value, 
                                         CM_field_id_t source3, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_mult_const_subf_const_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        double source3_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_mult_const_subf_const_a_1L _AP((CM_field_id_t dest, 
                                          CM_field_id_t source1, 
                                          double source2_value, 
                                          double source3_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_f_mult_sub_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source1, 
                           CM_field_id_t source2, 
                           CM_field_id_t source3, 
                           unsigned s, 
                           unsigned e));

void CM_f_mult_sub_always_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  CM_field_id_t source3, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_mult_sub_const_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 CM_field_id_t source2, 
                                 double source3_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_mult_sub_const_always_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        CM_field_id_t source2, 
                                        double source3_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_mult_subf_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            CM_field_id_t source3, 
                            unsigned s, 
                            unsigned e));

void CM_f_mult_subf_always_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   CM_field_id_t source2, 
                                   CM_field_id_t source3, 
                                   unsigned s, 
                                   unsigned e));

void CM_f_mult_subf_const_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  double source3_value, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_mult_subf_const_always_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         CM_field_id_t source2, 
                                         double source3_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_multiply_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned s, 
                             unsigned e));

void CM_f_multiply_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned s, 
                             unsigned e));

void CM_f_multiply_always_2_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_multiply_always_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    CM_field_id_t source2, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_multiply_const_always_2_1L _AP((CM_field_id_t dest, 
                                          double source_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_f_multiply_const_always_3_1L _AP((CM_field_id_t dest, 
                                          CM_field_id_t source1, 
                                          double source2_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_f_multiply_constant_2_1L _AP((CM_field_id_t dest, 
                                      double source_value, 
                                      unsigned s, 
                                      unsigned e));

void CM_f_multiply_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      double source2_value, 
                                      unsigned s, 
                                      unsigned e));

void CM_f_ne_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned s, 
                     unsigned e));

void CM_f_ne_constant_1L _AP((CM_field_id_t source1, 
                              double source2_value, 
                              unsigned s, 
                              unsigned e));

void CM_f_ne_zero_1L _AP((CM_field_id_t source1, 
                          unsigned s, 
                          unsigned e));

void CM_f_negate_1_1L _AP((CM_field_id_t dest, 
                           unsigned s, 
                           unsigned e));

void CM_f_negate_2_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned s, 
                           unsigned e));

void CM_f_news_add_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned axis, 
                             CM_communication_direction_t direction, 
                             unsigned s, 
                             unsigned e));

void CM_f_news_add_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned axis, 
                             CM_communication_direction_t direction, 
                             unsigned s, 
                             unsigned e));

void CM_f_news_add_always_2_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source, 
                                    unsigned axis, 
                                    CM_communication_direction_t direction, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_news_add_always_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    CM_field_id_t source2, 
                                    unsigned axis, 
                                    CM_communication_direction_t direction, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_news_add_const_3_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   double source2_value, 
                                   unsigned axis, 
                                   CM_communication_direction_t direction, 
                                   unsigned s, 
                                   unsigned e));

void CM_f_news_add_const_a_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     double source2_value, 
                                     unsigned axis, 
                                     CM_communication_direction_t direction, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_news_add_const_mult_4_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        CM_field_id_t source3, 
                                        unsigned axis, 
                                        CM_communication_direction_t direction, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_news_add_mult_4_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  CM_field_id_t source3, 
                                  unsigned axis, 
                                  CM_communication_direction_t direction, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_news_mult_2_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned axis, 
                              CM_communication_direction_t direction, 
                              unsigned s, 
                              unsigned e));

void CM_f_news_mult_3_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source1, 
                              CM_field_id_t source2, 
                              unsigned axis, 
                              CM_communication_direction_t direction, 
                              unsigned s, 
                              unsigned e));

void CM_f_news_mult_add_4_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  CM_field_id_t source3, 
                                  unsigned axis, 
                                  CM_communication_direction_t direction, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_news_mult_always_2_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source, 
                                     unsigned axis, 
                                     CM_communication_direction_t direction, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_news_mult_always_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     CM_field_id_t source2, 
                                     unsigned axis, 
                                     CM_communication_direction_t direction, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_news_mult_const_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    double source2_value, 
                                    unsigned axis, 
                                    CM_communication_direction_t direction, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_news_mult_const_a_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      double source2_value, 
                                      unsigned axis, 
                                      CM_communication_direction_t direction, 
                                      unsigned s, 
                                      unsigned e));

void CM_f_news_mult_const_add_4_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        CM_field_id_t source3, 
                                        unsigned axis, 
                                        CM_communication_direction_t direction, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_news_mult_const_sub_4_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        CM_field_id_t source3, 
                                        unsigned axis, 
                                        CM_communication_direction_t direction, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_news_mult_sub_4_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  CM_field_id_t source3, 
                                  unsigned axis, 
                                  CM_communication_direction_t direction, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_news_sub_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned axis, 
                             CM_communication_direction_t direction, 
                             unsigned s, 
                             unsigned e));

void CM_f_news_sub_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned axis, 
                             CM_communication_direction_t direction, 
                             unsigned s, 
                             unsigned e));

void CM_f_news_sub_always_2_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source, 
                                    unsigned axis, 
                                    CM_communication_direction_t direction, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_news_sub_always_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    CM_field_id_t source2, 
                                    unsigned axis, 
                                    CM_communication_direction_t direction, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_news_sub_const_3_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   double source2_value, 
                                   unsigned axis, 
                                   CM_communication_direction_t direction, 
                                   unsigned s, 
                                   unsigned e));

void CM_f_news_sub_const_a_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     double source2_value, 
                                     unsigned axis, 
                                     CM_communication_direction_t direction, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_news_sub_const_mult_4_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        CM_field_id_t source3, 
                                        unsigned axis, 
                                        CM_communication_direction_t direction, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_news_sub_mult_4_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  CM_field_id_t source3, 
                                  unsigned axis, 
                                  CM_communication_direction_t direction, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_random_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_rank_2L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned axis, 
                       unsigned dlen, 
                       unsigned s, 
                       unsigned e, 
                       CM_communication_direction_t direction, 
                       CM_segment_mode_t smode, 
                       CM_field_id_t sbit));

void CM_f_read_from_news_array_1L _AP((char *front_end_array, 
                                       unsigned *offset_vector, 
                                       unsigned *start_vector, 
                                       unsigned *end_vector, 
                                       unsigned *axis_vector, 
                                       CM_field_id_t source_field, 
                                       unsigned signif_len, 
                                       unsigned exp_len, 
                                       int rank, 
                                       unsigned *dimension_vector, 
                                       unsigned format));

double CM_f_read_from_processor_1L _AP((CM_sendaddr_t send_address_value, 
                                        CM_field_id_t source, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_rem_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_rem_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned s, 
                        unsigned e));

void CM_f_rem_constant_2_1L _AP((CM_field_id_t dest, 
                                 double source_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_rem_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 double source2_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_s_float_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned slen, 
                            unsigned s, 
                            unsigned e));

void CM_f_s_power_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned slen, 
                            unsigned s, 
                            unsigned e));

void CM_f_s_power_3_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned slen2, 
                            unsigned s, 
                            unsigned e));

void CM_f_s_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     int source_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_s_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_s_scale_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned slen, 
                            unsigned s, 
                            unsigned e));

void CM_f_s_scale_3_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned slen, 
                            unsigned s, 
                            unsigned e));

void CM_f_s_scale_constant_2_1L _AP((CM_field_id_t dest, 
                                     int constant, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_s_scale_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int constant, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_sin_1_1L _AP((CM_field_id_t dest, 
                        unsigned s, 
                        unsigned e));

void CM_f_sin_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_sinh_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_sinh_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_f_sqrt_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_sqrt_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_f_sub_const_mult_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 double source2_value, 
                                 CM_field_id_t source3, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_sub_const_mult_always_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        CM_field_id_t source3, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_sub_const_mult_const_1L _AP((CM_field_id_t dest, 
                                       CM_field_id_t source1, 
                                       double source2_value, 
                                       double source3_value, 
                                       unsigned s, 
                                       unsigned e));

void CM_f_sub_const_mult_const_a_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         double source2_value, 
                                         double source3_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_sub_mult_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source1, 
                           CM_field_id_t source2, 
                           CM_field_id_t source3, 
                           unsigned s, 
                           unsigned e));

void CM_f_sub_mult_always_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  CM_field_id_t source3, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_sub_mult_const_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 CM_field_id_t source2, 
                                 double source3_value, 
                                 unsigned s, 
                                 unsigned e));

void CM_f_sub_mult_const_always_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        CM_field_id_t source2, 
                                        double source3_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_subf_const_mult_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  double source2_value, 
                                  CM_field_id_t source3, 
                                  unsigned s, 
                                  unsigned e));

void CM_f_subf_const_mult_always_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         double source2_value, 
                                         CM_field_id_t source3, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_subf_const_mult_const_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        double source2_value, 
                                        double source3_value, 
                                        unsigned s, 
                                        unsigned e));

void CM_f_subf_const_mult_const_a_1L _AP((CM_field_id_t dest, 
                                          CM_field_id_t source1, 
                                          double source2_value, 
                                          double source3_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_f_subfrom_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            unsigned s, 
                            unsigned e));

void CM_f_subfrom_always_2_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   unsigned s, 
                                   unsigned e));

void CM_f_subfrom_const_always_2_1L _AP((CM_field_id_t dest, 
                                         double source1_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_subfrom_const_always_3_1L _AP((CM_field_id_t dest, 
                                         CM_field_id_t source1, 
                                         double source2_value, 
                                         unsigned s, 
                                         unsigned e));

void CM_f_subfrom_constant_2_1L _AP((CM_field_id_t dest, 
                                     double source1_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_subfrom_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     double source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_subtract_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned s, 
                             unsigned e));

void CM_f_subtract_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned s, 
                             unsigned e));

void CM_f_subtract_always_2_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_subtract_always_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    CM_field_id_t source2, 
                                    unsigned s, 
                                    unsigned e));

void CM_f_subtract_const_always_2_1L _AP((CM_field_id_t dest, 
                                          double source_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_f_subtract_const_always_3_1L _AP((CM_field_id_t dest, 
                                          CM_field_id_t source1, 
                                          double source2_value, 
                                          unsigned s, 
                                          unsigned e));

void CM_f_subtract_constant_2_1L _AP((CM_field_id_t dest, 
                                      double source_value, 
                                      unsigned s, 
                                      unsigned e));

void CM_f_subtract_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      double source2_value, 
                                      unsigned s, 
                                      unsigned e));

void CM_f_tan_1_1L _AP((CM_field_id_t dest, 
                        unsigned s, 
                        unsigned e));

void CM_f_tan_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned s, 
                        unsigned e));

void CM_f_tanh_1_1L _AP((CM_field_id_t dest, 
                         unsigned s, 
                         unsigned e));

void CM_f_tanh_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned s, 
                         unsigned e));

void CM_f_u_float_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned slen, 
                            unsigned s, 
                            unsigned e));

void CM_f_u_power_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned slen, 
                            unsigned s, 
                            unsigned e));

void CM_f_u_power_3_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned slen2, 
                            unsigned s, 
                            unsigned e));

void CM_f_u_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     unsigned source_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_u_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     unsigned source2_value, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_u_scale_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned slen, 
                            unsigned s, 
                            unsigned e));

void CM_f_u_scale_3_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned slen, 
                            unsigned s, 
                            unsigned e));

void CM_f_u_scale_constant_2_1L _AP((CM_field_id_t dest, 
                                     unsigned constant, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_u_scale_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     unsigned constant, 
                                     unsigned s, 
                                     unsigned e));

void CM_f_vax_to_ieee_1L _AP((CM_field_id_t ieee_dest_field, 
                              CM_field_id_t vax_source_field, 
                              unsigned float_length));

void CM_f_write_to_news_array_1L _AP((char *front_end_array, 
                                      unsigned *offset_vector, 
                                      unsigned *start_vector, 
                                      unsigned *end_vector, 
                                      unsigned *axis_vector, 
                                      CM_field_id_t dest_field, 
                                      unsigned signif_len, 
                                      unsigned exp_len, 
                                      int rank, 
                                      unsigned *dimension_vector, 
                                      CM_array_format_t format));

void CM_f_write_to_processor_1L _AP((CM_sendaddr_t send_address_value, 
                                     CM_field_id_t dest, 
                                     double source_value, 
                                     unsigned s, 
                                     unsigned e));

CM_array_format_t CM_fe_array_format _AP((int cm_element_size, 
                                          int array_element_size, 
                                          int stride, 
                                          unsigned ordering));

unsigned CM_fe_deposit_news_coordinate _AP((CM_geometry_id_t geometry_id, 
                                            CM_sendaddr_t send_address, 
                                            unsigned axis, 
                                            unsigned news_coordinate));

CM_multicoord_t CM_fe_extract_multi_coordinate _AP((CM_geometry_id_t geometry_id, 
                                                    unsigned axis_mask, 
                                                    CM_sendaddr_t send_address));

unsigned CM_fe_extract_news_coordinate _AP((CM_geometry_id_t geometry_id, 
                                            unsigned axis, 
                                            CM_sendaddr_t send_address));

unsigned CM_fe_from_gray_code _AP((unsigned code));

unsigned CM_fe_gray_code_from_integer _AP((unsigned a));

unsigned CM_fe_integer_from_gray_code _AP((unsigned gray_code));

unsigned CM_fe_make_news_coordinate _AP((CM_geometry_id_t geometry_id, 
                                         unsigned axis, 
                                         unsigned news_coordinate));

unsigned CM_fe_make_news_mask _AP((unsigned axis_length, 
                                   unsigned forbidden_bits, 
                                   unsigned len));

CM_array_format_t CM_fe_packed_array_format _AP((int cm_element_size, 
                                                 int array_element_size));

CM_array_format_t CM_fe_structure_array_format _AP((int cm_element_byte_size, 
                                                    int structure_byte_size));

unsigned CM_fe_to_gray_code _AP((unsigned number));

CM_vp_set_id_t CM_field_vp_set _AP((CM_field_id_t field_id));

unsigned CM_geometry_axis_length _AP((CM_geometry_id_t geometry_id, 
                                      unsigned axis));

unsigned CM_geometry_axis_off_chip_bits _AP((CM_geometry_id_t geometry_id, 
                                             unsigned axis));

unsigned CM_geometry_axis_off_chip_pos _AP((CM_geometry_id_t geometry_id, 
                                            unsigned axis));

unsigned CM_geometry_axis_on_chip_bits _AP((CM_geometry_id_t geometry_id, 
                                            unsigned axis));

unsigned CM_geometry_axis_on_chip_pos _AP((CM_geometry_id_t geometry_id, 
                                           unsigned axis));

CM_axis_order_t CM_geometry_axis_ordering _AP((CM_geometry_id_t geometry_id, 
                                               unsigned axis));

unsigned CM_geometry_axis_vp_ratio _AP((CM_geometry_id_t geometry_id, 
                                        unsigned axis));

unsigned CM_geometry_coordinate_length _AP((CM_geometry_id_t geometry_id, 
                                            unsigned axis));

int CM_geometry_rank _AP((CM_geometry_id_t geometry_id));

unsigned CM_geometry_send_address_length _AP((CM_geometry_id_t geometry_id));

int CM_geometry_serial_number _AP((CM_geometry_id_t geometry_id));

int CM_geometry_total_processors _AP((CM_geometry_id_t geometry_id));

int CM_geometry_total_vp_ratio _AP((CM_geometry_id_t geometry_id));

void CM_get_1L _AP((CM_field_id_t dest, 
                    CM_field_id_t send_address, 
                    CM_field_id_t source, 
                    unsigned len));

void CM_get_aref32_2L _AP((CM_field_id_t dest, 
                           CM_field_id_t send_address, 
                           CM_field_id_t array, 
                           CM_field_id_t index, 
                           unsigned dlen, 
                           unsigned index_len, 
                           unsigned index_limit));

void CM_get_from_news_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned axis, 
                              CM_communication_direction_t direction, 
                              unsigned len));

void CM_get_from_news_always_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source, 
                                     unsigned axis, 
                                     CM_communication_direction_t direction, 
                                     unsigned len));

void CM_get_from_power_two_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis, 
                                   unsigned log_distance_2, 
                                   CM_communication_direction_t direction, 
                                   unsigned len));

void CM_get_from_power_two_always_1L _AP((CM_field_id_t dest, 
                                          CM_field_id_t source, 
                                          unsigned axis, 
                                          unsigned log_distance_2, 
                                          CM_communication_direction_t direction, 
                                          unsigned len));

CM_complex_t CM_global_c_add_1L _AP((CM_field_id_t source, 
                                     unsigned s, 
                                     unsigned e));

unsigned CM_global_count_bit _AP((CM_field_id_t source));

unsigned CM_global_count_bit_always _AP((CM_field_id_t source));

unsigned CM_global_count_context _AP((void));

unsigned CM_global_count_overflow _AP((void));

unsigned CM_global_count_test _AP((void));

double CM_global_f_add_1L _AP((CM_field_id_t source, 
                               unsigned s, 
                               unsigned e));

double CM_global_f_max_1L _AP((CM_field_id_t source, 
                               unsigned s, 
                               unsigned e));

double CM_global_f_min_1L _AP((CM_field_id_t source, 
                               unsigned s, 
                               unsigned e));

int CM_global_logand_1L _AP((CM_field_id_t source, 
                             unsigned len));

unsigned CM_global_logand_bit _AP((CM_field_id_t source));

unsigned CM_global_logand_bit_always _AP((CM_field_id_t source));

unsigned CM_global_logand_context _AP((void));

unsigned CM_global_logand_overflow _AP((void));

unsigned CM_global_logand_test _AP((void));

int CM_global_logior_1L _AP((CM_field_id_t source, 
                             unsigned len));

unsigned CM_global_logior_bit _AP((CM_field_id_t source));

unsigned CM_global_logior_bit_always _AP((CM_field_id_t source));

unsigned CM_global_logior_context _AP((void));

unsigned CM_global_logior_overflow _AP((void));

unsigned CM_global_logior_test _AP((void));

unsigned CM_global_logxor_1L _AP((CM_field_id_t source, 
                                  unsigned len));

int CM_global_s_add_1L _AP((CM_field_id_t source, 
                            unsigned len));

int CM_global_s_max_1L _AP((CM_field_id_t source, 
                            unsigned len));

int CM_global_s_min_1L _AP((CM_field_id_t source, 
                            unsigned len));

unsigned CM_global_u_add_1L _AP((CM_field_id_t source, 
                                 unsigned len));

unsigned CM_global_u_max_1L _AP((CM_field_id_t source, 
                                 unsigned len));

unsigned CM_global_u_max_s_intlen_1L _AP((CM_field_id_t source, 
                                          unsigned len));

unsigned CM_global_u_max_u_intlen_1L _AP((CM_field_id_t source, 
                                          unsigned len));

unsigned CM_global_u_min_1L _AP((CM_field_id_t source, 
                                 unsigned len));

void CM_initialize_random_generator _AP((unsigned seed));

CM_geometry_id_t CM_intern_geometry _AP((unsigned *dimension_array, 
                                         unsigned rank));

CM_vp_set_id_t CM_intern_identical_vp_set _AP((CM_geometry_id_t geometry_id));

void CM_invert_context _AP((void));

void CM_invert_overflow _AP((void));

void CM_invert_overflow_always _AP((void));

void CM_invert_test _AP((void));

void CM_invert_test_always _AP((void));

int CM_is_field_an_alias _AP((CM_field_id_t field_id));

int CM_is_field_in_heap _AP((CM_field_id_t field_id));

int CM_is_field_in_stack _AP((CM_field_id_t field_id));

int CM_is_field_valid _AP((CM_field_id_t field_id));

int CM_is_stack_field_newer _AP((CM_field_id_t stack_base_field, 
                                 CM_field_id_t stack_query_field));

int CM_is_vp_set_valid _AP((CM_vp_set_id_t vp_set_id));

void CM_latch_leds _AP((CM_field_id_t source));

void CM_latch_leds_always _AP((CM_field_id_t source));

void CM_load_context _AP((CM_field_id_t source));

void CM_load_overflow _AP((CM_field_id_t source));

void CM_load_overflow_always _AP((CM_field_id_t source));

void CM_load_test _AP((CM_field_id_t source));

void CM_load_test_always _AP((CM_field_id_t source));

void CM_logand_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned len));

void CM_logand_3_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source1, 
                         CM_field_id_t source2, 
                         unsigned len));

void CM_logand_always_2_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned len));

void CM_logand_always_3_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source1, 
                                CM_field_id_t source2, 
                                unsigned len));

void CM_logand_const_always_2_1L _AP((CM_field_id_t dest, 
                                      unsigned source_value, 
                                      unsigned len));

void CM_logand_const_always_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      unsigned source2_value, 
                                      unsigned len));

void CM_logand_constant_2_1L _AP((CM_field_id_t dest, 
                                  unsigned source_value, 
                                  unsigned len));

void CM_logand_constant_3_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  unsigned source2_value, 
                                  unsigned len));

void CM_logand_context _AP((CM_field_id_t source));

void CM_logand_context_with_test _AP((void));

void CM_logand_overflow _AP((CM_field_id_t source));

void CM_logand_overflow_always _AP((CM_field_id_t source));

void CM_logand_test _AP((CM_field_id_t source));

void CM_logand_test_always _AP((CM_field_id_t source));

void CM_logandc1_2_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned len));

void CM_logandc1_3_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source1, 
                           CM_field_id_t source2, 
                           unsigned len));

void CM_logandc1_always_2_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned len));

void CM_logandc1_always_3_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  unsigned len));

void CM_logandc1_const_always_2_1L _AP((CM_field_id_t dest, 
                                        unsigned source_value, 
                                        unsigned len));

void CM_logandc1_const_always_3_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        unsigned source2_value, 
                                        unsigned len));

void CM_logandc1_constant_2_1L _AP((CM_field_id_t dest, 
                                    unsigned source_value, 
                                    unsigned len));

void CM_logandc1_constant_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    unsigned source2_value, 
                                    unsigned len));

void CM_logandc2_2_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned len));

void CM_logandc2_3_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source1, 
                           CM_field_id_t source2, 
                           unsigned len));

void CM_logandc2_always_2_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned len));

void CM_logandc2_always_3_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  CM_field_id_t source2, 
                                  unsigned len));

void CM_logandc2_const_always_2_1L _AP((CM_field_id_t dest, 
                                        unsigned source_value, 
                                        unsigned len));

void CM_logandc2_const_always_3_1L _AP((CM_field_id_t dest, 
                                        CM_field_id_t source1, 
                                        unsigned source2_value, 
                                        unsigned len));

void CM_logandc2_constant_2_1L _AP((CM_field_id_t dest, 
                                    unsigned source_value, 
                                    unsigned len));

void CM_logandc2_constant_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    unsigned source2_value, 
                                    unsigned len));

void CM_logeqv_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned len));

void CM_logeqv_3_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source1, 
                         CM_field_id_t source2, 
                         unsigned len));

void CM_logeqv_always_2_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned len));

void CM_logeqv_always_3_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source1, 
                                CM_field_id_t source2, 
                                unsigned len));

void CM_logeqv_const_always_2_1L _AP((CM_field_id_t dest, 
                                      unsigned source_value, 
                                      unsigned len));

void CM_logeqv_const_always_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      unsigned source2_value, 
                                      unsigned len));

void CM_logeqv_constant_2_1L _AP((CM_field_id_t dest, 
                                  unsigned source_value, 
                                  unsigned len));

void CM_logeqv_constant_3_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  unsigned source2_value, 
                                  unsigned len));

void CM_logior_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned len));

void CM_logior_3_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source1, 
                         CM_field_id_t source2, 
                         unsigned len));

void CM_logior_always_2_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned len));

void CM_logior_always_3_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source1, 
                                CM_field_id_t source2, 
                                unsigned len));

void CM_logior_const_always_2_1L _AP((CM_field_id_t dest, 
                                      unsigned source_value, 
                                      unsigned len));

void CM_logior_const_always_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      unsigned source2_value, 
                                      unsigned len));

void CM_logior_constant_2_1L _AP((CM_field_id_t dest, 
                                  unsigned source_value, 
                                  unsigned len));

void CM_logior_constant_3_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  unsigned source2_value, 
                                  unsigned len));

void CM_logior_context _AP((CM_field_id_t source));

void CM_logior_overflow _AP((CM_field_id_t source));

void CM_logior_overflow_always _AP((CM_field_id_t source));

void CM_logior_test _AP((CM_field_id_t source));

void CM_logior_test_always _AP((CM_field_id_t source));

void CM_lognand_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned len));

void CM_lognand_3_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned len));

void CM_lognand_always_2_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned len));

void CM_lognand_always_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 CM_field_id_t source2, 
                                 unsigned len));

void CM_lognand_const_always_2_1L _AP((CM_field_id_t dest, 
                                       unsigned source_value, 
                                       unsigned len));

void CM_lognand_const_always_3_1L _AP((CM_field_id_t dest, 
                                       CM_field_id_t source1, 
                                       unsigned source2_value, 
                                       unsigned len));

void CM_lognand_constant_2_1L _AP((CM_field_id_t dest, 
                                   unsigned source_value, 
                                   unsigned len));

void CM_lognand_constant_3_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   unsigned source2_value, 
                                   unsigned len));

void CM_lognor_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned len));

void CM_lognor_3_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source1, 
                         CM_field_id_t source2, 
                         unsigned len));

void CM_lognor_always_2_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned len));

void CM_lognor_always_3_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source1, 
                                CM_field_id_t source2, 
                                unsigned len));

void CM_lognor_const_always_2_1L _AP((CM_field_id_t dest, 
                                      unsigned source_value, 
                                      unsigned len));

void CM_lognor_const_always_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      unsigned source2_value, 
                                      unsigned len));

void CM_lognor_constant_2_1L _AP((CM_field_id_t dest, 
                                  unsigned source_value, 
                                  unsigned len));

void CM_lognor_constant_3_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  unsigned source2_value, 
                                  unsigned len));

void CM_lognot_1_1L _AP((CM_field_id_t dest, 
                         unsigned len));

void CM_lognot_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned len));

void CM_lognot_always_1_1L _AP((CM_field_id_t dest, 
                                unsigned len));

void CM_lognot_always_2_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned len));

void CM_logorc1_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned len));

void CM_logorc1_3_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned len));

void CM_logorc1_always_2_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned len));

void CM_logorc1_always_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 CM_field_id_t source2, 
                                 unsigned len));

void CM_logorc1_const_always_2_1L _AP((CM_field_id_t dest, 
                                       unsigned source_value, 
                                       unsigned len));

void CM_logorc1_const_always_3_1L _AP((CM_field_id_t dest, 
                                       CM_field_id_t source1, 
                                       unsigned source2_value, 
                                       unsigned len));

void CM_logorc1_constant_2_1L _AP((CM_field_id_t dest, 
                                   unsigned source2_value, 
                                   unsigned len));

void CM_logorc1_constant_3_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   unsigned source2_value, 
                                   unsigned len));

void CM_logorc2_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned len));

void CM_logorc2_3_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned len));

void CM_logorc2_always_2_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned len));

void CM_logorc2_always_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 CM_field_id_t source2, 
                                 unsigned len));

void CM_logorc2_const_always_2_1L _AP((CM_field_id_t dest, 
                                       unsigned source_value, 
                                       unsigned len));

void CM_logorc2_const_always_3_1L _AP((CM_field_id_t dest, 
                                       CM_field_id_t source1, 
                                       unsigned source2_value, 
                                       unsigned len));

void CM_logorc2_constant_2_1L _AP((CM_field_id_t dest, 
                                   unsigned source2_value, 
                                   unsigned len));

void CM_logorc2_constant_3_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   unsigned source2_value, 
                                   unsigned len));

void CM_logxor_2_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source, 
                         unsigned len));

void CM_logxor_3_1L _AP((CM_field_id_t dest, 
                         CM_field_id_t source1, 
                         CM_field_id_t source2, 
                         unsigned len));

void CM_logxor_always_2_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned len));

void CM_logxor_always_3_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source1, 
                                CM_field_id_t source2, 
                                unsigned len));

void CM_logxor_const_always_2_1L _AP((CM_field_id_t dest, 
                                      unsigned source_value, 
                                      unsigned len));

void CM_logxor_const_always_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      unsigned source2_value, 
                                      unsigned len));

void CM_logxor_constant_2_1L _AP((CM_field_id_t dest, 
                                  unsigned source_value, 
                                  unsigned len));

void CM_logxor_constant_3_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source1, 
                                  unsigned source2_value, 
                                  unsigned len));

CM_field_id_t CM_make_field_alias _AP((CM_field_id_t field_id));

void CM_make_news_coordinate_1L _AP((CM_geometry_id_t geometry_id, 
                                     CM_field_id_t dest, 
                                     unsigned axis, 
                                     CM_field_id_t news_coordinate, 
                                     unsigned slen));

void CM_move_reversed_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned len));

void CM_move_reversed_always_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source, 
                                     unsigned len));

void CM_multispread_c_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned s, 
                                  unsigned e));

void CM_multispread_copy_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned axis_mask, 
                                 unsigned len, 
                                 CM_multicoord_t coordinate));

void CM_multispread_f_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned s, 
                                  unsigned e));

void CM_multispread_f_max_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned s, 
                                  unsigned e));

void CM_multispread_f_min_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned s, 
                                  unsigned e));

void CM_multispread_logand_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis_mask, 
                                   unsigned len));

void CM_multispread_logior_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis_mask, 
                                   unsigned len));

void CM_multispread_logxor_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis_mask, 
                                   unsigned len));

void CM_multispread_s_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned len));

void CM_multispread_s_max_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned len));

void CM_multispread_s_min_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned len));

void CM_multispread_u_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned len));

void CM_multispread_u_max_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned len));

void CM_multispread_u_min_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis_mask, 
                                  unsigned len));

void CM_my_news_coordinate_1L _AP((CM_field_id_t dest, 
                                   unsigned axis, 
                                   unsigned dlen));

void CM_my_send_address _AP((CM_field_id_t dest));

void CM_my_send_address_1L _AP((CM_field_id_t dest));

int CM_next_stack_field_id _AP((void));

void CM_permuted_get_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t send_address, 
                             CM_field_id_t source, 
                             unsigned len));

void CM_permuted_send_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t send_address, 
                              CM_field_id_t source, 
                              unsigned len, 
                              CM_field_id_t notify));

CM_vp_set_id_t CM_physical_vp_set _AP((void));

void CM_reduce_with_c_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned s, 
                                  unsigned e, 
                                  unsigned deposit_coord));

void CM_reduce_with_copy_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned axis, 
                                 unsigned len, 
                                 unsigned deposit_coord, 
                                 unsigned extract_coord));

void CM_reduce_with_f_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned s, 
                                  unsigned e, 
                                  unsigned deposit_coord));

void CM_reduce_with_f_max_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned s, 
                                  unsigned e, 
                                  unsigned deposit_coord));

void CM_reduce_with_f_min_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned s, 
                                  unsigned e, 
                                  unsigned deposit_coord));

void CM_reduce_with_logand_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis, 
                                   unsigned len, 
                                   unsigned deposit_coord));

void CM_reduce_with_logior_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis, 
                                   unsigned len, 
                                   unsigned deposit_coord));

void CM_reduce_with_logxor_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis, 
                                   unsigned len, 
                                   unsigned deposit_coord));

void CM_reduce_with_s_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len, 
                                  unsigned deposit_coord));

void CM_reduce_with_s_max_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len, 
                                  unsigned deposit_coord));

void CM_reduce_with_s_min_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len, 
                                  unsigned deposit_coord));

void CM_reduce_with_u_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len, 
                                  unsigned deposit_coord));

void CM_reduce_with_u_max_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len, 
                                  unsigned deposit_coord));

void CM_reduce_with_u_min_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len, 
                                  unsigned deposit_coord));

void CM_remove_field_alias _AP((CM_field_id_t field_id));

void CM_s_abs_1_1L _AP((CM_field_id_t dest, 
                        unsigned len));

void CM_s_abs_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_s_abs_2_2L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned dlen, 
                        unsigned slen));

void CM_s_add_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_s_add_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_s_add_3_3L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned dlen, 
                        unsigned slen1, 
                        unsigned slen2));

void CM_s_add_carry_2_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned len));

void CM_s_add_carry_3_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source1, 
                              CM_field_id_t source2, 
                              unsigned len));

void CM_s_add_carry_3_3L _AP((CM_field_id_t dest, 
                              CM_field_id_t source1, 
                              CM_field_id_t source2, 
                              unsigned dlen, 
                              unsigned slen1, 
                              unsigned slen2));

void CM_s_add_constant_2_1L _AP((CM_field_id_t dest, 
                                 int source_value, 
                                 unsigned len));

void CM_s_add_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 int source2_value, 
                                 unsigned len));

void CM_s_add_flags_2_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned len));

void CM_s_ceiling_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned len));

void CM_s_ceiling_3_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned len));

void CM_s_ceiling_3_3L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned dlen, 
                            unsigned slen1, 
                            unsigned slen2));

void CM_s_ceiling_constant_2_1L _AP((CM_field_id_t dest, 
                                     int source_value, 
                                     unsigned len));

void CM_s_ceiling_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned len));

void CM_s_compare_3_3L _AP((CM_field_id_t destination, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned dlen, 
                            unsigned slen1, 
                            unsigned slen2));

void CM_s_eq_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_s_eq_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_s_eq_constant_1L _AP((CM_field_id_t source1, 
                              int source2_value, 
                              unsigned len));

void CM_s_eq_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_s_f_ceiling_2_2L _AP((CM_field_id_t destination, 
                              CM_field_id_t source, 
                              unsigned dlen, 
                              unsigned s, 
                              unsigned e));

void CM_s_f_floor_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned dlen, 
                            unsigned s, 
                            unsigned e));

void CM_s_f_round_2_2L _AP((CM_field_id_t destination, 
                            CM_field_id_t source, 
                            unsigned dlen, 
                            unsigned s, 
                            unsigned e));

void CM_s_f_signum_2_2L _AP((CM_field_id_t destination, 
                             CM_field_id_t source, 
                             unsigned dlen, 
                             unsigned s, 
                             unsigned e));

void CM_s_f_truncate_2_2L _AP((CM_field_id_t dest, 
                               CM_field_id_t source, 
                               unsigned dlen, 
                               unsigned s, 
                               unsigned e));

void CM_s_floor_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned len));

void CM_s_floor_3_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned len));

void CM_s_floor_3_3L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned dlen, 
                          unsigned slen1, 
                          unsigned slen2));

void CM_s_floor_constant_2_1L _AP((CM_field_id_t dest, 
                                   int source_value, 
                                   unsigned len));

void CM_s_floor_constant_3_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   int source2_value, 
                                   unsigned len));

void CM_s_ge_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_s_ge_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_s_ge_constant_1L _AP((CM_field_id_t source1, 
                              int source2_value, 
                              unsigned len));

void CM_s_ge_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_s_gt_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_s_gt_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_s_gt_constant_1L _AP((CM_field_id_t source1, 
                              int source2_value, 
                              unsigned len));

void CM_s_gt_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_s_integer_length_2_2L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned dlen, 
                                   unsigned slen));

void CM_s_isqrt_1_1L _AP((CM_field_id_t dest, 
                          unsigned len));

void CM_s_isqrt_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned len));

void CM_s_isqrt_2_2L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned dlen, 
                          unsigned slen));

void CM_s_le_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_s_le_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_s_le_constant_1L _AP((CM_field_id_t source1, 
                              int source2_value, 
                              unsigned len));

void CM_s_le_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_s_logcount_2_2L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned dlen, 
                             unsigned slen));

void CM_s_lt_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_s_lt_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_s_lt_constant_1L _AP((CM_field_id_t source1, 
                              int source2_value, 
                              unsigned len));

void CM_s_lt_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_s_max_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_s_max_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_s_max_3_3L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned dlen, 
                        unsigned slen1, 
                        unsigned slen2));

void CM_s_max_constant_2_1L _AP((CM_field_id_t dest, 
                                 int source_value, 
                                 unsigned len));

void CM_s_max_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 int source2_value, 
                                 unsigned len));

void CM_s_min_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_s_min_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_s_min_3_3L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned dlen, 
                        unsigned slen1, 
                        unsigned slen2));

void CM_s_min_constant_2_1L _AP((CM_field_id_t dest, 
                                 int source_value, 
                                 unsigned len));

void CM_s_min_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 int source2_value, 
                                 unsigned len));

void CM_s_mod_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_s_mod_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_s_mod_3_2L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned slen1, 
                        unsigned slen2));

void CM_s_mod_constant_2_1L _AP((CM_field_id_t dest, 
                                 int source_value, 
                                 unsigned len));

void CM_s_mod_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 int source2_value, 
                                 unsigned len));

void CM_s_move_1L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned len));

void CM_s_move_2L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned dlen, 
                       unsigned slen));

void CM_s_move_always_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned len));

void CM_s_move_const_always_1L _AP((CM_field_id_t dest, 
                                    int source_value, 
                                    unsigned len));

void CM_s_move_constant_1L _AP((CM_field_id_t dest, 
                                int source_value, 
                                unsigned len));

void CM_s_move_zero_1L _AP((CM_field_id_t dest, 
                            unsigned len));

void CM_s_move_zero_always_1L _AP((CM_field_id_t dest, 
                                   unsigned len));

void CM_s_multiply_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned len));

void CM_s_multiply_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned len));

void CM_s_multiply_3_3L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned dlen, 
                             unsigned slen1, 
                             unsigned slen2));

void CM_s_multiply_constant_2_1L _AP((CM_field_id_t dest, 
                                      int source_value, 
                                      unsigned len));

void CM_s_multiply_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      int source2_value, 
                                      unsigned len));

void CM_s_ne_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_s_ne_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_s_ne_constant_1L _AP((CM_field_id_t source1, 
                              int source2_value, 
                              unsigned len));

void CM_s_ne_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_s_negate_1_1L _AP((CM_field_id_t dest, 
                           unsigned len));

void CM_s_negate_2_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned len));

void CM_s_negate_2_2L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned dlen, 
                           unsigned slen));

void CM_s_rank_2L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned axis, 
                       unsigned dlen, 
                       unsigned slen, 
                       CM_communication_direction_t direction, 
                       CM_segment_mode_t smode, 
                       CM_field_id_t sbit));

void CM_s_read_from_news_array_1L _AP((char *front_end_array, 
                                       unsigned *offset_vector, 
                                       unsigned *start_vector, 
                                       unsigned *end_vector, 
                                       unsigned *axis_vector, 
                                       CM_field_id_t source_field, 
                                       unsigned length, 
                                       int rank, 
                                       unsigned *dimension_vector, 
                                       unsigned format));

int CM_s_read_from_processor_1L _AP((CM_sendaddr_t send_address_value, 
                                     CM_field_id_t source, 
                                     unsigned len));

void CM_s_rem_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_s_rem_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_s_rem_constant_2_1L _AP((CM_field_id_t dest, 
                                 int source_value, 
                                 unsigned len));

void CM_s_rem_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 int source2_value, 
                                 unsigned len));

void CM_s_resize_field_always _AP((CM_field_id_t field_id, 
                                   unsigned new_length));

void CM_s_round_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned len));

void CM_s_round_3_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned len));

void CM_s_round_3_3L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned dlen, 
                          unsigned slen1, 
                          unsigned slen2));

void CM_s_round_constant_2_1L _AP((CM_field_id_t dest, 
                                   int source_value, 
                                   unsigned len));

void CM_s_round_constant_3_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   int source2_value, 
                                   unsigned len));

void CM_s_s_power_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned len));

void CM_s_s_power_3_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned len));

void CM_s_s_power_3_3L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned dlen, 
                            unsigned slen1, 
                            unsigned slen2));

void CM_s_s_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     int source2_value, 
                                     unsigned len));

void CM_s_s_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned len));

void CM_s_s_power_constant_3_2L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned dlen, 
                                     unsigned slen));

void CM_s_s_shift_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned dlen, 
                            unsigned slen));

void CM_s_s_shift_constant_3_2L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned dlen, 
                                     unsigned slen));

void CM_s_s_signum_1_1L _AP((CM_field_id_t dest, 
                             unsigned len));

void CM_s_s_signum_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned len));

void CM_s_s_signum_2_2L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned dlen, 
                             unsigned slen));

void CM_s_subfrom_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            unsigned len));

void CM_s_subfrom_constant_2_1L _AP((CM_field_id_t dest, 
                                     int source1_value, 
                                     unsigned len));

void CM_s_subfrom_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned len));

void CM_s_subtract_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned len));

void CM_s_subtract_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned len));

void CM_s_subtract_3_3L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned dlen, 
                             unsigned slen1, 
                             unsigned slen2));

void CM_s_subtract_borrow_2_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source, 
                                    unsigned len));

void CM_s_subtract_borrow_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    CM_field_id_t source2, 
                                    unsigned len));

void CM_s_subtract_constant_2_1L _AP((CM_field_id_t dest, 
                                      int source_value, 
                                      unsigned len));

void CM_s_subtract_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      int source2_value, 
                                      unsigned len));

void CM_s_truncate_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned len));

void CM_s_truncate_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned len));

void CM_s_truncate_3_3L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned dlen, 
                             unsigned slen1, 
                             unsigned slen2));

void CM_s_truncate_constant_2_1L _AP((CM_field_id_t dest, 
                                      int source_value, 
                                      unsigned len));

void CM_s_truncate_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      int source2_value, 
                                      unsigned len));

void CM_s_u_power_3_3L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned dlen, 
                            unsigned slen1, 
                            unsigned slen2));

void CM_s_u_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     int source2_value, 
                                     unsigned len));

void CM_s_u_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned len));

void CM_s_u_power_constant_3_2L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned dlen, 
                                     unsigned slen));

void CM_s_write_to_news_array_1L _AP((char *front_end_array, 
                                      unsigned *offset_vector, 
                                      unsigned *start_vector, 
                                      unsigned *end_vector, 
                                      unsigned *axis_vector, 
                                      CM_field_id_t dest_field, 
                                      unsigned length, 
                                      int rank, 
                                      unsigned *dimension_vector, 
                                      CM_array_format_t format));

void CM_s_write_to_processor_1L _AP((CM_sendaddr_t send_address_value, 
                                     CM_field_id_t dest, 
                                     int source_value, 
                                     unsigned len));

void CM_scan_with_c_add_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned s, 
                                unsigned e, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_scan_with_copy_1L _AP((CM_field_id_t dest, 
                               CM_field_id_t source, 
                               unsigned axis, 
                               unsigned len, 
                               CM_communication_direction_t direction, 
                               CM_scan_inclusion_t inclusion, 
                               CM_segment_mode_t smode, 
                               CM_field_id_t sbit));

void CM_scan_with_f_add_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned s, 
                                unsigned e, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_scan_with_f_max_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned s, 
                                unsigned e, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_scan_with_f_min_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned s, 
                                unsigned e, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_scan_with_f_multiply_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source, 
                                     unsigned axis, 
                                     unsigned s, 
                                     unsigned e, 
                                     CM_communication_direction_t direction, 
                                     CM_scan_inclusion_t inclusion, 
                                     CM_segment_mode_t smode, 
                                     CM_field_id_t sbit));

void CM_scan_with_logand_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned axis, 
                                 unsigned len, 
                                 CM_communication_direction_t direction, 
                                 CM_scan_inclusion_t inclusion, 
                                 CM_segment_mode_t smode, 
                                 CM_field_id_t sbit));

void CM_scan_with_logior_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned axis, 
                                 unsigned len, 
                                 CM_communication_direction_t direction, 
                                 CM_scan_inclusion_t inclusion, 
                                 CM_segment_mode_t smode, 
                                 CM_field_id_t sbit));

void CM_scan_with_logxor_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned axis, 
                                 unsigned len, 
                                 CM_communication_direction_t direction, 
                                 CM_scan_inclusion_t inclusion, 
                                 CM_segment_mode_t smode, 
                                 CM_field_id_t sbit));

void CM_scan_with_s_add_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned len, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_scan_with_s_max_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned len, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_scan_with_s_min_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned len, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_scan_with_u_add_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned len, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_scan_with_u_max_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned len, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_scan_with_u_min_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t source, 
                                unsigned axis, 
                                unsigned len, 
                                CM_communication_direction_t direction, 
                                CM_scan_inclusion_t inclusion, 
                                CM_segment_mode_t smode, 
                                CM_field_id_t sbit));

void CM_send_1L _AP((CM_field_id_t dest, 
                     CM_field_id_t send_address, 
                     CM_field_id_t source, 
                     unsigned len, 
                     CM_field_id_t notify));

void CM_send_aset32_logior_2L _AP((CM_field_id_t array, 
                                   CM_field_id_t send_address, 
                                   CM_field_id_t source, 
                                   CM_field_id_t index, 
                                   unsigned slen, 
                                   unsigned index_len, 
                                   unsigned index_limit));

void CM_send_aset32_overwrite_2L _AP((CM_field_id_t array, 
                                      CM_field_id_t send_address, 
                                      CM_field_id_t source, 
                                      CM_field_id_t index, 
                                      unsigned slen, 
                                      unsigned index_len, 
                                      unsigned index_limit));

void CM_send_aset32_u_add_2L _AP((CM_field_id_t array, 
                                  CM_field_id_t send_address, 
                                  CM_field_id_t source, 
                                  CM_field_id_t index, 
                                  unsigned slen, 
                                  unsigned index_len, 
                                  unsigned index_limit));

void CM_send_to_news_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned axis, 
                             CM_communication_direction_t up_or_down, 
                             unsigned len));

void CM_send_to_news_always_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source, 
                                    unsigned axis, 
                                    CM_communication_direction_t up_or_down, 
                                    unsigned len));

void CM_send_to_queue32_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned len, 
                                unsigned index_limit));

void CM_send_to_shared_queue32_1L _AP((CM_field_id_t dest, 
                                       CM_field_id_t chip_address, 
                                       CM_field_id_t source, 
                                       unsigned len, 
                                       unsigned max_slices));

void CM_send_with_c_add_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned s, 
                                unsigned e, 
                                CM_field_id_t notify));

void CM_send_with_f_add_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned s, 
                                unsigned e, 
                                CM_field_id_t notify));

void CM_send_with_f_max_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned s, 
                                unsigned e, 
                                CM_field_id_t notify));

void CM_send_with_f_min_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned s, 
                                unsigned e, 
                                CM_field_id_t notify));

void CM_send_with_logand_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t send_address, 
                                 CM_field_id_t source, 
                                 unsigned len, 
                                 CM_field_id_t notify));

void CM_send_with_logior_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t send_address, 
                                 CM_field_id_t source, 
                                 unsigned len, 
                                 CM_field_id_t notify));

void CM_send_with_logxor_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t send_address, 
                                 CM_field_id_t source, 
                                 unsigned len, 
                                 CM_field_id_t notify));

void CM_send_with_overwrite_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t send_address, 
                                    CM_field_id_t source, 
                                    unsigned len, 
                                    CM_field_id_t notify));

void CM_send_with_s_add_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned len, 
                                CM_field_id_t notify));

void CM_send_with_s_max_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned len, 
                                CM_field_id_t notify));

void CM_send_with_s_min_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned len, 
                                CM_field_id_t notify));

void CM_send_with_u_add_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned len, 
                                CM_field_id_t notify));

void CM_send_with_u_max_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned len, 
                                CM_field_id_t notify));

void CM_send_with_u_min_1L _AP((CM_field_id_t dest, 
                                CM_field_id_t send_address, 
                                CM_field_id_t source, 
                                unsigned len, 
                                CM_field_id_t notify));

void CM_set_bit _AP((CM_field_id_t dest));

void CM_set_bit_always _AP((CM_field_id_t dest));

void CM_set_context _AP((void));

void CM_set_field_alias_vp_set _AP((CM_field_id_t field_id, 
                                    CM_vp_set_id_t vp_set_id));

void CM_set_overflow _AP((void));

void CM_set_safety_mode _AP((unsigned safety_mode));

int CM_set_system_leds_mode _AP((int mode));

void CM_set_test _AP((void));

void CM_set_vp_set _AP((CM_vp_set_id_t vp_set_id));

void CM_set_vp_set_geometry _AP((CM_vp_set_id_t vp_set_id, 
                                 CM_geometry_id_t geometry_id));

void CM_spread_from_processor_1L _AP((CM_field_id_t dest_field_id, 
                                      CM_sendaddr_t send_address_value, 
                                      CM_field_id_t source_field_id, 
                                      unsigned len));

void CM_spread_from_processor_a_1L _AP((CM_field_id_t dest_field_id, 
                                        CM_sendaddr_t send_address_value, 
                                        CM_field_id_t source_field_id, 
                                        unsigned len));

void CM_spread_with_c_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned s, 
                                  unsigned e));

void CM_spread_with_copy_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned axis, 
                                 unsigned len, 
                                 unsigned coordinate));

void CM_spread_with_f_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned s, 
                                  unsigned e));

void CM_spread_with_f_max_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned s, 
                                  unsigned e));

void CM_spread_with_f_min_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned s, 
                                  unsigned e));

void CM_spread_with_logand_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis, 
                                   unsigned len));

void CM_spread_with_logior_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis, 
                                   unsigned len));

void CM_spread_with_logxor_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned axis, 
                                   unsigned len));

void CM_spread_with_s_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len));

void CM_spread_with_s_max_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len));

void CM_spread_with_s_min_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len));

void CM_spread_with_u_add_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len));

void CM_spread_with_u_max_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len));

void CM_spread_with_u_min_1L _AP((CM_field_id_t dest, 
                                  CM_field_id_t source, 
                                  unsigned axis, 
                                  unsigned len));

void CM_store_context _AP((CM_field_id_t dest));

void CM_store_overflow _AP((CM_field_id_t dest));

void CM_store_overflow_always _AP((CM_field_id_t dest));

void CM_store_test _AP((CM_field_id_t dest));

void CM_store_test_always _AP((CM_field_id_t dest));

void CM_swap_2_1L _AP((CM_field_id_t dest1, 
                       CM_field_id_t dest2, 
                       unsigned len));

void CM_swap_always_2_1L _AP((CM_field_id_t dest1, 
                              CM_field_id_t dest2, 
                              unsigned len));

void CM_timer_clear _AP((unsigned timer));

void CM_timer_print _AP((unsigned timer));

double CM_timer_read_cm_busy _AP((unsigned timer));

double CM_timer_read_cm_idle _AP((unsigned timer));

double CM_timer_read_elapsed _AP((unsigned timer));

int CM_timer_read_run_state _AP((unsigned timer));

int CM_timer_read_starts _AP((unsigned timer));

void CM_timer_set_starts _AP((unsigned timer, 
                              unsigned value));

void CM_timer_start _AP((unsigned timer));

void CM_timer_stop _AP((unsigned timer));

void CM_transpose32_1_1L _AP((CM_field_id_t dest, 
                              unsigned length));

void CM_transpose32_2_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned length));

void CM_u_add_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_u_add_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_u_add_3_3L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned dlen, 
                        unsigned slen1, 
                        unsigned slen2));

void CM_u_add_carry_2_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned len));

void CM_u_add_carry_3_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source1, 
                              CM_field_id_t source2, 
                              unsigned len));

void CM_u_add_carry_3_3L _AP((CM_field_id_t dest, 
                              CM_field_id_t source1, 
                              CM_field_id_t source2, 
                              unsigned dlen, 
                              unsigned slen1, 
                              unsigned slen2));

void CM_u_add_constant_2_1L _AP((CM_field_id_t dest, 
                                 unsigned source_value, 
                                 unsigned len));

void CM_u_add_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 unsigned source2_value, 
                                 unsigned len));

void CM_u_add_flags_2_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned len));

void CM_u_ceiling_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned len));

void CM_u_ceiling_3_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned len));

void CM_u_ceiling_3_3L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned dlen, 
                            unsigned slen1, 
                            unsigned slen2));

void CM_u_ceiling_constant_2_1L _AP((CM_field_id_t dest, 
                                     unsigned source_value, 
                                     unsigned len));

void CM_u_ceiling_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     unsigned source2_value, 
                                     unsigned len));

void CM_u_compare_3_3L _AP((CM_field_id_t destination, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned dlen, 
                            unsigned slen1, 
                            unsigned slen2));

void CM_u_eq_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_u_eq_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_u_eq_constant_1L _AP((CM_field_id_t source1, 
                              unsigned source2_value, 
                              unsigned len));

void CM_u_eq_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_u_f_ceiling_2_2L _AP((CM_field_id_t destination, 
                              CM_field_id_t source, 
                              unsigned dlen, 
                              unsigned s, 
                              unsigned e));

void CM_u_f_floor_2_2L _AP((CM_field_id_t destination, 
                            CM_field_id_t source, 
                            unsigned dlen, 
                            unsigned s, 
                            unsigned e));

void CM_u_f_round_2_2L _AP((CM_field_id_t destination, 
                            CM_field_id_t source, 
                            unsigned dlen, 
                            unsigned s, 
                            unsigned e));

void CM_u_f_truncate_2_2L _AP((CM_field_id_t destination, 
                               CM_field_id_t source, 
                               unsigned dlen, 
                               unsigned s, 
                               unsigned e));

void CM_u_floor_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned len));

void CM_u_floor_3_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned len));

void CM_u_floor_3_3L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned dlen, 
                          unsigned slen1, 
                          unsigned slen2));

void CM_u_floor_constant_2_1L _AP((CM_field_id_t dest, 
                                   unsigned source_value, 
                                   unsigned len));

void CM_u_floor_constant_3_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   unsigned source2_value, 
                                   unsigned len));

void CM_u_from_gray_code_1_1L _AP((CM_field_id_t dest, 
                                   unsigned len));

void CM_u_from_gray_code_2_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned len));

void CM_u_ge_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_u_ge_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_u_ge_constant_1L _AP((CM_field_id_t source1, 
                              unsigned source2_value, 
                              unsigned len));

void CM_u_ge_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_u_gt_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_u_gt_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_u_gt_constant_1L _AP((CM_field_id_t source1, 
                              unsigned source2_value, 
                              unsigned len));

void CM_u_gt_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_u_integer_length_2_2L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source, 
                                   unsigned dlen, 
                                   unsigned slen));

void CM_u_isqrt_1_1L _AP((CM_field_id_t dest, 
                          unsigned len));

void CM_u_isqrt_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned len));

void CM_u_isqrt_2_2L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned dlen, 
                          unsigned slen));

void CM_u_le_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_u_le_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_u_le_constant_1L _AP((CM_field_id_t source1, 
                              unsigned source2_value, 
                              unsigned len));

void CM_u_le_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_u_logcount_2_2L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned dlen, 
                             unsigned slen));

void CM_u_lt_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_u_lt_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_u_lt_constant_1L _AP((CM_field_id_t source1, 
                              unsigned source2_value, 
                              unsigned len));

void CM_u_lt_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_u_max_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_u_max_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_u_max_3_3L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned dlen, 
                        unsigned slen1, 
                        unsigned slen2));

void CM_u_max_constant_2_1L _AP((CM_field_id_t dest, 
                                 unsigned source2_value, 
                                 unsigned len));

void CM_u_max_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 unsigned source2_value, 
                                 unsigned len));

void CM_u_min_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_u_min_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_u_min_3_3L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned dlen, 
                        unsigned slen1, 
                        unsigned slen2));

void CM_u_min_constant_2_1L _AP((CM_field_id_t dest, 
                                 unsigned source2_value, 
                                 unsigned len));

void CM_u_min_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 unsigned source2_value, 
                                 unsigned len));

void CM_u_mod_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_u_mod_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_u_mod_3_2L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned slen1, 
                        unsigned slen2));

void CM_u_mod_constant_2_1L _AP((CM_field_id_t dest, 
                                 unsigned source_value, 
                                 unsigned len));

void CM_u_mod_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 unsigned source2_value, 
                                 unsigned len));

void CM_u_move_1L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned len));

void CM_u_move_2L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned dlen, 
                       unsigned slen));

void CM_u_move_always_1L _AP((CM_field_id_t dest, 
                              CM_field_id_t source, 
                              unsigned len));

void CM_u_move_const_always_1L _AP((CM_field_id_t dest, 
                                    unsigned source_value, 
                                    unsigned len));

void CM_u_move_constant_1L _AP((CM_field_id_t dest, 
                                unsigned source_value, 
                                unsigned len));

void CM_u_move_zero_1L _AP((CM_field_id_t dest, 
                            unsigned len));

void CM_u_move_zero_always_1L _AP((CM_field_id_t dest, 
                                   unsigned len));

void CM_u_multiply_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned len));

void CM_u_multiply_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned len));

void CM_u_multiply_3_3L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned dlen, 
                             unsigned slen1, 
                             unsigned slen2));

void CM_u_multiply_constant_2_1L _AP((CM_field_id_t dest, 
                                      unsigned source_value, 
                                      unsigned len));

void CM_u_multiply_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      unsigned source2_value, 
                                      unsigned len));

void CM_u_ne_1L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned len));

void CM_u_ne_2L _AP((CM_field_id_t source1, 
                     CM_field_id_t source2, 
                     unsigned slen1, 
                     unsigned slen2));

void CM_u_ne_constant_1L _AP((CM_field_id_t source1, 
                              unsigned source2_value, 
                              unsigned len));

void CM_u_ne_zero_1L _AP((CM_field_id_t source1, 
                          unsigned len));

void CM_u_negate_1_1L _AP((CM_field_id_t dest, 
                           unsigned len));

void CM_u_negate_2_1L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned len));

void CM_u_negate_2_2L _AP((CM_field_id_t dest, 
                           CM_field_id_t source, 
                           unsigned dlen, 
                           unsigned slen));

void CM_u_random_1L _AP((CM_field_id_t dest, 
                         unsigned len, 
                         unsigned limit));

void CM_u_rank_2L _AP((CM_field_id_t dest, 
                       CM_field_id_t source, 
                       unsigned axis, 
                       unsigned dlen, 
                       unsigned slen, 
                       CM_communication_direction_t direction, 
                       CM_segment_mode_t smode, 
                       CM_field_id_t sbit));

void CM_u_read_from_news_array_1L _AP((char *front_end_array, 
                                       unsigned *offset_vector, 
                                       unsigned *start_vector, 
                                       unsigned *end_vector, 
                                       unsigned *axis_vector, 
                                       CM_field_id_t source_field, 
                                       unsigned length, 
                                       int rank, 
                                       unsigned *dimension_vector, 
                                       unsigned format));

unsigned CM_u_read_from_processor_1L _AP((CM_sendaddr_t send_address_value, 
                                          CM_field_id_t source, 
                                          unsigned len));

void CM_u_rem_2_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source, 
                        unsigned len));

void CM_u_rem_3_1L _AP((CM_field_id_t dest, 
                        CM_field_id_t source1, 
                        CM_field_id_t source2, 
                        unsigned len));

void CM_u_rem_constant_2_1L _AP((CM_field_id_t dest, 
                                 unsigned source_value, 
                                 unsigned len));

void CM_u_rem_constant_3_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source1, 
                                 unsigned source2_value, 
                                 unsigned len));

void CM_u_resize_field_always _AP((CM_field_id_t field_id, 
                                   unsigned new_length));

void CM_u_round_2_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source, 
                          unsigned len));

void CM_u_round_3_1L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned len));

void CM_u_round_3_3L _AP((CM_field_id_t dest, 
                          CM_field_id_t source1, 
                          CM_field_id_t source2, 
                          unsigned dlen, 
                          unsigned slen1, 
                          unsigned slen2));

void CM_u_round_constant_2_1L _AP((CM_field_id_t dest, 
                                   unsigned source_value, 
                                   unsigned len));

void CM_u_round_constant_3_1L _AP((CM_field_id_t dest, 
                                   CM_field_id_t source1, 
                                   unsigned source2_value, 
                                   unsigned len));

void CM_u_s_power_3_3L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned dlen, 
                            unsigned slen1, 
                            unsigned slen2));

void CM_u_s_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     int source2_value, 
                                     unsigned len));

void CM_u_s_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned len));

void CM_u_s_power_constant_3_2L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned dlen, 
                                     unsigned slen));

void CM_u_s_shift_2_2L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned dlen, 
                            unsigned slen));

void CM_u_s_shift_constant_3_2L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned dlen, 
                                     unsigned slen));

void CM_u_subfrom_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            unsigned len));

void CM_u_subfrom_constant_2_1L _AP((CM_field_id_t dest, 
                                     unsigned source1_value, 
                                     unsigned len));

void CM_u_subfrom_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     unsigned source2_value, 
                                     unsigned len));

void CM_u_subtract_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned len));

void CM_u_subtract_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned len));

void CM_u_subtract_3_3L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned dlen, 
                             unsigned slen1, 
                             unsigned slen2));

void CM_u_subtract_borrow_2_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source, 
                                    unsigned len));

void CM_u_subtract_borrow_3_1L _AP((CM_field_id_t dest, 
                                    CM_field_id_t source1, 
                                    CM_field_id_t source2, 
                                    unsigned len));

void CM_u_subtract_constant_2_1L _AP((CM_field_id_t dest, 
                                      unsigned source_value, 
                                      unsigned len));

void CM_u_subtract_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      unsigned source2_value, 
                                      unsigned len));

void CM_u_to_gray_code_1_1L _AP((CM_field_id_t dest, 
                                 unsigned len));

void CM_u_to_gray_code_2_1L _AP((CM_field_id_t dest, 
                                 CM_field_id_t source, 
                                 unsigned len));

void CM_u_truncate_2_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source, 
                             unsigned len));

void CM_u_truncate_3_1L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned len));

void CM_u_truncate_3_3L _AP((CM_field_id_t dest, 
                             CM_field_id_t source1, 
                             CM_field_id_t source2, 
                             unsigned dlen, 
                             unsigned slen1, 
                             unsigned slen2));

void CM_u_truncate_constant_2_1L _AP((CM_field_id_t dest, 
                                      unsigned source_value, 
                                      unsigned len));

void CM_u_truncate_constant_3_1L _AP((CM_field_id_t dest, 
                                      CM_field_id_t source1, 
                                      unsigned source2_value, 
                                      unsigned len));

void CM_u_u_power_2_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source, 
                            unsigned len));

void CM_u_u_power_3_1L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned len));

void CM_u_u_power_3_3L _AP((CM_field_id_t dest, 
                            CM_field_id_t source1, 
                            CM_field_id_t source2, 
                            unsigned dlen, 
                            unsigned slen1, 
                            unsigned slen2));

void CM_u_u_power_constant_2_1L _AP((CM_field_id_t dest, 
                                     int source2_value, 
                                     unsigned len));

void CM_u_u_power_constant_3_1L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned len));

void CM_u_u_power_constant_3_2L _AP((CM_field_id_t dest, 
                                     CM_field_id_t source1, 
                                     int source2_value, 
                                     unsigned dlen, 
                                     unsigned slen));

void CM_u_write_to_news_array_1L _AP((char *front_end_array, 
                                      unsigned *offset_vector, 
                                      unsigned *start_vector, 
                                      unsigned *end_vector, 
                                      unsigned *axis_vector, 
                                      CM_field_id_t dest_field, 
                                      unsigned length, 
                                      int rank, 
                                      unsigned *dimension_vector, 
                                      CM_array_format_t format));

void CM_u_write_to_processor_1L _AP((CM_sendaddr_t send_address_value, 
                                     CM_field_id_t dest, 
                                     unsigned source_value, 
                                     unsigned len));

CM_geometry_id_t CM_vp_set_geometry _AP((CM_vp_set_id_t vp_set_id));

CM_geometry_id_t CM_create_detailed_geometry _AP((CM_axis_descriptor_t axes[],
		                                  unsigned rank));

                     
CM_geometry_id_t CM_intern_detailed_geometry _AP((CM_axis_descriptor_t axes[],
                                                  unsigned rank));
#endif /* _PARIS_ */
